// SPDX-License-Identifier: GPL-2.0-only
/*
 * Copyright (c) 2022 MediaTek Inc.
 * Author: Chris-qj Chen <chris-qj.chen@mediatek.com>
 */

#include <common.h>
#include <dm.h>
#include <asm/io.h>
#include <dt-bindings/clock/mt8188-clk.h>
#include <linux/bitops.h>

#include "clk-mtk.h"

const struct mtk_fixed_clk top_fixed_clks[] = {
	FIXED_CLK(CLK_TOP_ULPOSC1, 0, 260000000),
	FIXED_CLK(CLK_TOP_MPHONE_SLAVE_BCK, 0, 49152000),
	FIXED_CLK(CLK_TOP_PAD_FPC, 0, 50000000),
	FIXED_CLK(CLK_TOP_466M_FMEM, 0, 533000000),
	FIXED_CLK(CLK_TOP_PEXTP_PIPE, 0, 250000000),
	FIXED_CLK(CLK_TOP_DSI_PHY, 0, 500000000),
	FIXED_CLK(CLK_TOP_CLK26M, CLK_XTAL, 26000000),
	FIXED_CLK(CLK_TOP_CLK32K, CLK_XTAL, 32000),
	FIXED_CLK(CLK_TOP_CLK13M, CLK_XTAL, 13000000),
};

const struct mtk_fixed_factor top_fixed_divs[] = {
	FACTOR(CLK_TOP_MFGPLL, CLK_APMIXED_MFGPLL, 1, 1, CLK_PARENT_APMIXED),
	FACTOR(CLK_TOP_MAINPLL, CLK_APMIXED_MAINPLL, 1, 1, CLK_PARENT_APMIXED),
	FACTOR(CLK_TOP_MAINPLL_D3, CLK_TOP_MAINPLL, 1, 3, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_MAINPLL_D4, CLK_TOP_MAINPLL, 1, 4, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_MAINPLL_D4_D2, CLK_TOP_MAINPLL_D4, 1, 2, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_MAINPLL_D4_D4, CLK_TOP_MAINPLL_D4, 1, 4, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_MAINPLL_D4_D8, CLK_TOP_MAINPLL_D4, 1, 8, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_MAINPLL_D5, CLK_TOP_MAINPLL, 1, 5, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_MAINPLL_D5_D2, CLK_TOP_MAINPLL_D5, 1, 2, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_MAINPLL_D5_D4, CLK_TOP_MAINPLL_D5, 1, 4, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_MAINPLL_D5_D8, CLK_TOP_MAINPLL_D5, 1, 8, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_MAINPLL_D6, CLK_TOP_MAINPLL, 1, 6, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_MAINPLL_D6_D2, CLK_TOP_MAINPLL_D6, 1, 2, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_MAINPLL_D6_D4, CLK_TOP_MAINPLL_D6, 1, 4, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_MAINPLL_D6_D8, CLK_TOP_MAINPLL_D6, 1, 8, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_MAINPLL_D7, CLK_TOP_MAINPLL, 1, 7, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_MAINPLL_D7_D2, CLK_TOP_MAINPLL_D7, 1, 2, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_MAINPLL_D7_D4, CLK_TOP_MAINPLL_D7, 1, 4, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_MAINPLL_D7_D8, CLK_TOP_MAINPLL_D7, 1, 8, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_MAINPLL_D9, CLK_TOP_MAINPLL, 1, 9, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_UNIVPLL, CLK_APMIXED_UNIVPLL, 1, 1, CLK_PARENT_APMIXED),
	FACTOR(CLK_TOP_UNIVPLL_D2, CLK_TOP_UNIVPLL, 1, 2, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_UNIVPLL_D3, CLK_TOP_UNIVPLL, 1, 3, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_UNIVPLL_D4, CLK_TOP_UNIVPLL, 1, 4, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_UNIVPLL_D4_D2, CLK_TOP_UNIVPLL_D4, 1, 2, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_UNIVPLL_D4_D4, CLK_TOP_UNIVPLL_D4, 1, 4, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_UNIVPLL_D4_D8, CLK_TOP_UNIVPLL_D4, 1, 8, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_UNIVPLL_D5, CLK_TOP_UNIVPLL, 1, 5, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_UNIVPLL_D5_D2, CLK_TOP_UNIVPLL_D5, 1, 2, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_UNIVPLL_D5_D4, CLK_TOP_UNIVPLL_D5, 1, 4, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_UNIVPLL_D5_D8, CLK_TOP_UNIVPLL_D5, 1, 8, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_UNIVPLL_D6, CLK_TOP_UNIVPLL, 1, 6, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_UNIVPLL_D6_D2, CLK_TOP_UNIVPLL_D6, 1, 2, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_UNIVPLL_D6_D4, CLK_TOP_UNIVPLL_D6, 1, 4, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_UNIVPLL_D6_D8, CLK_TOP_UNIVPLL_D6, 1, 8, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_UNIVPLL_D7, CLK_TOP_UNIVPLL, 1, 7, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_UNIVPLL_192M, CLK_TOP_UNIVPLL, 1, 13, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_UNIVPLL_192M_D4, CLK_TOP_UNIVPLL_192M, 1, 4, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_UNIVPLL_192M_D8, CLK_TOP_UNIVPLL_192M, 1, 8, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_UNIVPLL_192M_D10, CLK_TOP_UNIVPLL_192M, 1, 10, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_UNIVPLL_192M_D16, CLK_TOP_UNIVPLL_192M, 1, 16, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_UNIVPLL_192M_D32, CLK_TOP_UNIVPLL_192M, 1, 32, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_IMGPLL, CLK_APMIXED_IMGPLL, 1, 1, CLK_PARENT_APMIXED),
	FACTOR(CLK_TOP_APLL1_D3, CLK_APMIXED_APLL1, 1, 3, CLK_PARENT_APMIXED),
	FACTOR(CLK_TOP_APLL1_D4, CLK_APMIXED_APLL1, 1, 4, CLK_PARENT_APMIXED),
	FACTOR(CLK_TOP_APLL2_D3, CLK_APMIXED_APLL2, 1, 3, CLK_PARENT_APMIXED),
	FACTOR(CLK_TOP_APLL2_D4, CLK_APMIXED_APLL2, 1, 4, CLK_PARENT_APMIXED),
	FACTOR(CLK_TOP_APLL3_D4, CLK_APMIXED_APLL3, 1, 4, CLK_PARENT_APMIXED),
	FACTOR(CLK_TOP_APLL4_D4, CLK_APMIXED_APLL4, 1, 4, CLK_PARENT_APMIXED),
	FACTOR(CLK_TOP_APLL5_D4, CLK_APMIXED_APLL5, 1, 4, CLK_PARENT_APMIXED),
	FACTOR(CLK_TOP_MMPLL, CLK_APMIXED_MMPLL, 1, 1, CLK_PARENT_APMIXED),
	FACTOR(CLK_TOP_MMPLL_D4, CLK_TOP_MMPLL, 1, 4, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_MMPLL_D4_D2, CLK_TOP_MMPLL_D4, 1, 2, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_MMPLL_D5, CLK_TOP_MMPLL, 1, 5, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_MMPLL_D5_D2, CLK_TOP_MMPLL_D5, 1, 2, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_MMPLL_D5_D4, CLK_TOP_MMPLL_D5, 1, 4, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_MMPLL_D6, CLK_TOP_MMPLL, 1, 6, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_MMPLL_D6_D2, CLK_TOP_MMPLL_D6, 1, 2, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_MMPLL_D7, CLK_TOP_MMPLL, 1, 7, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_MMPLL_D9, CLK_TOP_MMPLL, 1, 9, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_TVDPLL1, CLK_APMIXED_TVDPLL1, 1, 1, CLK_PARENT_APMIXED),
	FACTOR(CLK_TOP_TVDPLL1_D2, CLK_TOP_TVDPLL1, 1, 2, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_TVDPLL1_D4, CLK_TOP_TVDPLL1, 1, 4, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_TVDPLL1_D8, CLK_TOP_TVDPLL1, 1, 8, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_TVDPLL1_D16, CLK_TOP_TVDPLL1, 1, 16, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_TVDPLL2, CLK_APMIXED_TVDPLL2, 1, 1, CLK_PARENT_APMIXED),
	FACTOR(CLK_TOP_TVDPLL2_D2, CLK_TOP_TVDPLL2, 1, 2, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_TVDPLL2_D4, CLK_TOP_TVDPLL2, 1, 4, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_TVDPLL2_D8, CLK_TOP_TVDPLL2, 1, 8, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_TVDPLL2_D16, CLK_TOP_TVDPLL2, 1, 16, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_MSDCPLL, CLK_APMIXED_MSDCPLL, 1, 1, CLK_PARENT_APMIXED),
	FACTOR(CLK_TOP_MSDCPLL_D2, CLK_TOP_MSDCPLL, 1, 2, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_MSDCPLL_D16, CLK_TOP_MSDCPLL, 1, 16, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_ETHPLL, CLK_APMIXED_ETHPLL, 1, 1, CLK_PARENT_APMIXED),
	FACTOR(CLK_TOP_ETHPLL_D2, CLK_TOP_ETHPLL, 1, 2, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_ETHPLL_D4, CLK_TOP_ETHPLL, 1, 4, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_ETHPLL_D8, CLK_TOP_ETHPLL, 1, 8, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_ETHPLL_D10, CLK_TOP_ETHPLL, 1, 10, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_ADSPPLL, CLK_APMIXED_ADSPPLL, 1, 1, CLK_PARENT_APMIXED),
	FACTOR(CLK_TOP_ADSPPLL_D2, CLK_TOP_ADSPPLL, 1, 2, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_ADSPPLL_D4, CLK_TOP_ADSPPLL, 1, 4, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_ADSPPLL_D8, CLK_TOP_ADSPPLL, 1, 8, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_ULPOSC1_D2, CLK_TOP_ULPOSC1, 1, 2, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_ULPOSC1_D4, CLK_TOP_ULPOSC1, 1, 4, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_ULPOSC1_D8, CLK_TOP_ULPOSC1, 1, 8, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_ULPOSC1_D7, CLK_TOP_ULPOSC1, 1, 7, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_ULPOSC1_D10, CLK_TOP_ULPOSC1, 1, 10, CLK_PARENT_TOPCKGEN),
	FACTOR(CLK_TOP_ULPOSC1_D16, CLK_TOP_ULPOSC1, 1, 16, CLK_PARENT_TOPCKGEN),
};

static const int axi_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_MAINPLL_D4_D4,
	CLK_TOP_MAINPLL_D7_D2,
	CLK_TOP_MAINPLL_D4_D2,
	CLK_TOP_MAINPLL_D5_D2,
	CLK_TOP_MAINPLL_D6_D2,
	CLK_TOP_ULPOSC1_D4
};

static const int spm_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_ULPOSC1_D10,
	CLK_TOP_MAINPLL_D7_D4,
	CLK_TOP_CLK32K
};

static const int scp_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D4,
	CLK_TOP_MAINPLL_D6,
	CLK_TOP_UNIVPLL_D6,
	CLK_TOP_UNIVPLL_D4_D2,
	CLK_TOP_MAINPLL_D4_D2,
	CLK_TOP_UNIVPLL_D3,
	CLK_TOP_MAINPLL_D3
};

static const int bus_aximem_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_MAINPLL_D7_D2,
	CLK_TOP_MAINPLL_D4_D2,
	CLK_TOP_MAINPLL_D5_D2,
	CLK_TOP_MAINPLL_D6
};

static const int vpp_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D6_D2,
	CLK_TOP_MAINPLL_D5_D2,
	CLK_TOP_MMPLL_D6_D2,
	CLK_TOP_UNIVPLL_D5_D2,
	CLK_TOP_UNIVPLL_D4_D2,
	CLK_TOP_MMPLL_D4_D2,
	CLK_TOP_MMPLL_D7,
	CLK_TOP_UNIVPLL_D6,
	CLK_TOP_MAINPLL_D4,
	CLK_TOP_MMPLL_D5,
	CLK_TOP_TVDPLL1,
	CLK_TOP_TVDPLL2,
	CLK_TOP_UNIVPLL_D4,
	CLK_TOP_MMPLL_D4
};

static const int ethdr_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D6_D2,
	CLK_TOP_MAINPLL_D5_D2,
	CLK_TOP_MMPLL_D6_D2,
	CLK_TOP_UNIVPLL_D5_D2,
	CLK_TOP_UNIVPLL_D4_D2,
	CLK_TOP_MMPLL_D4_D2,
	CLK_TOP_MMPLL_D7,
	CLK_TOP_UNIVPLL_D6,
	CLK_TOP_MAINPLL_D4,
	CLK_TOP_MMPLL_D5_D4,
	CLK_TOP_TVDPLL1,
	CLK_TOP_TVDPLL2,
	CLK_TOP_UNIVPLL_D4,
	CLK_TOP_MMPLL_D4
};

static const int ipe_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_IMGPLL,
	CLK_TOP_MAINPLL_D4,
	CLK_TOP_MMPLL_D6,
	CLK_TOP_UNIVPLL_D6,
	CLK_TOP_MAINPLL_D6,
	CLK_TOP_MMPLL_D4_D2,
	CLK_TOP_UNIVPLL_D4_D2,
	CLK_TOP_MAINPLL_D4_D2,
	CLK_TOP_MMPLL_D6_D2,
	CLK_TOP_UNIVPLL_D5_D2,
	CLK_TOP_MAINPLL_D7
};

static const int cam_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_TVDPLL1,
	CLK_TOP_MAINPLL_D4,
	CLK_TOP_MMPLL_D4,
	CLK_TOP_UNIVPLL_D4,
	CLK_TOP_UNIVPLL_D5,
	CLK_TOP_UNIVPLL_D6,
	CLK_TOP_MMPLL_D7,
	CLK_TOP_UNIVPLL_D4_D2,
	CLK_TOP_MAINPLL_D4_D2,
	CLK_TOP_IMGPLL
};

static const int ccu_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D6,
	CLK_TOP_MAINPLL_D4_D2,
	CLK_TOP_MAINPLL_D4,
	CLK_TOP_UNIVPLL_D5,
	CLK_TOP_MAINPLL_D6,
	CLK_TOP_MMPLL_D6,
	CLK_TOP_MMPLL_D7,
	CLK_TOP_UNIVPLL_D4_D2,
	CLK_TOP_UNIVPLL_D7
};

static const int ccu_ahb_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D6,
	CLK_TOP_MAINPLL_D4_D2,
	CLK_TOP_MAINPLL_D4,
	CLK_TOP_UNIVPLL_D5,
	CLK_TOP_MAINPLL_D6,
	CLK_TOP_MMPLL_D6,
	CLK_TOP_MMPLL_D7,
	CLK_TOP_UNIVPLL_D4_D2,
	CLK_TOP_UNIVPLL_D7
};

static const int img_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_IMGPLL,
	CLK_TOP_UNIVPLL_D4,
	CLK_TOP_MAINPLL_D4,
	CLK_TOP_UNIVPLL_D5,
	CLK_TOP_MMPLL_D6,
	CLK_TOP_MMPLL_D7,
	CLK_TOP_UNIVPLL_D6,
	CLK_TOP_MAINPLL_D6,
	CLK_TOP_MMPLL_D4_D2,
	CLK_TOP_UNIVPLL_D4_D2,
	CLK_TOP_MAINPLL_D4_D2,
	CLK_TOP_UNIVPLL_D5_D2
};

static const int camtm_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D4_D4,
	CLK_TOP_UNIVPLL_D6_D2,
	CLK_TOP_UNIVPLL_D6_D4
};

static const int dsp_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D6_D2,
	CLK_TOP_UNIVPLL_D4_D2,
	CLK_TOP_UNIVPLL_D5,
	CLK_TOP_UNIVPLL_D4,
	CLK_TOP_MMPLL_D4,
	CLK_TOP_MAINPLL_D3,
	CLK_TOP_UNIVPLL_D3
};

static const int dsp1_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D6_D2,
	CLK_TOP_MAINPLL_D4_D2,
	CLK_TOP_UNIVPLL_D5,
	CLK_TOP_MMPLL_D5,
	CLK_TOP_UNIVPLL_D4,
	CLK_TOP_MAINPLL_D3,
	CLK_TOP_UNIVPLL_D3
};

static const int dsp2_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D6_D2,
	CLK_TOP_MAINPLL_D4_D2,
	CLK_TOP_UNIVPLL_D5,
	CLK_TOP_MMPLL_D5,
	CLK_TOP_UNIVPLL_D4,
	CLK_TOP_MAINPLL_D3,
	CLK_TOP_UNIVPLL_D3
};

static const int dsp3_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D6_D2,
	CLK_TOP_MAINPLL_D4_D2,
	CLK_TOP_UNIVPLL_D5,
	CLK_TOP_MMPLL_D5,
	CLK_TOP_UNIVPLL_D4,
	CLK_TOP_MAINPLL_D3,
	CLK_TOP_UNIVPLL_D3
};

static const int dsp4_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D6_D2,
	CLK_TOP_UNIVPLL_D4_D2,
	CLK_TOP_MAINPLL_D4,
	CLK_TOP_UNIVPLL_D4,
	CLK_TOP_MMPLL_D4,
	CLK_TOP_MAINPLL_D3,
	CLK_TOP_UNIVPLL_D3
};

static const int dsp5_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D6_D2,
	CLK_TOP_UNIVPLL_D4_D2,
	CLK_TOP_MAINPLL_D4,
	CLK_TOP_UNIVPLL_D4,
	CLK_TOP_MMPLL_D4,
	CLK_TOP_MAINPLL_D3,
	CLK_TOP_UNIVPLL_D3
};

static const int dsp6_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D6_D2,
	CLK_TOP_UNIVPLL_D4_D2,
	CLK_TOP_MAINPLL_D4,
	CLK_TOP_UNIVPLL_D4,
	CLK_TOP_MMPLL_D4,
	CLK_TOP_MAINPLL_D3,
	CLK_TOP_UNIVPLL_D3
};

static const int dsp7_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D6_D2,
	CLK_TOP_UNIVPLL_D4_D2,
	CLK_TOP_UNIVPLL_D5,
	CLK_TOP_UNIVPLL_D4,
	CLK_TOP_MMPLL_D4,
	CLK_TOP_MAINPLL_D3,
	CLK_TOP_UNIVPLL_D3
};

static const int mfg_core_tmp_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_MAINPLL_D5_D2,
	CLK_TOP_UNIVPLL_D6,
	CLK_TOP_UNIVPLL_D7
};

static const int camtg_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_192M_D8,
	CLK_TOP_UNIVPLL_D6_D8,
	CLK_TOP_UNIVPLL_192M_D4,
	CLK_TOP_UNIVPLL_192M_D10,
	CLK_TOP_CLK13M,
	CLK_TOP_UNIVPLL_192M_D16,
	CLK_TOP_UNIVPLL_192M_D32
};

static const int camtg2_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_192M_D8,
	CLK_TOP_UNIVPLL_D6_D8,
	CLK_TOP_UNIVPLL_192M_D4,
	CLK_TOP_UNIVPLL_192M_D10,
	CLK_TOP_CLK13M,
	CLK_TOP_UNIVPLL_192M_D16,
	CLK_TOP_UNIVPLL_192M_D32
};

static const int camtg3_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_192M_D8,
	CLK_TOP_UNIVPLL_D6_D8,
	CLK_TOP_UNIVPLL_192M_D4,
	CLK_TOP_UNIVPLL_192M_D10,
	CLK_TOP_CLK13M,
	CLK_TOP_UNIVPLL_192M_D16,
	CLK_TOP_UNIVPLL_192M_D32
};

static const int uart_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D6_D8
};

static const int spi_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_MAINPLL_D5_D4,
	CLK_TOP_MAINPLL_D6_D4,
	CLK_TOP_UNIVPLL_D6_D4,
	CLK_TOP_UNIVPLL_D6_D2,
	CLK_TOP_MAINPLL_D6_D2,
	CLK_TOP_MAINPLL_D4_D4,
	CLK_TOP_UNIVPLL_D5_D4
};

static const int msdc5hclk_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_MAINPLL_D4_D2,
	CLK_TOP_MAINPLL_D6_D2
};

static const int msdc50_0_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_MSDCPLL,
	CLK_TOP_MSDCPLL_D2,
	CLK_TOP_UNIVPLL_D4_D4,
	CLK_TOP_MAINPLL_D6_D2,
	CLK_TOP_UNIVPLL_D4_D2
};

static const int msdc30_1_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D6_D2,
	CLK_TOP_MAINPLL_D6_D2,
	CLK_TOP_MAINPLL_D7_D2,
	CLK_TOP_MSDCPLL_D2
};

static const int msdc30_2_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D6_D2,
	CLK_TOP_MAINPLL_D6_D2,
	CLK_TOP_MAINPLL_D7_D2,
	CLK_TOP_MSDCPLL_D2
};

static const int intdir_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D6,
	CLK_TOP_MAINPLL_D4,
	CLK_TOP_UNIVPLL_D4
};

static const int aud_intbus_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_MAINPLL_D4_D4,
	CLK_TOP_MAINPLL_D7_D4
};

static const int audio_h_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D7,
	CLK_TOP_APLL1,
	CLK_TOP_APLL2
};

static const int pwrap_ulposc_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_ULPOSC1_D10,
	CLK_TOP_ULPOSC1_D7,
	CLK_TOP_ULPOSC1_D8,
	CLK_TOP_ULPOSC1_D16,
	CLK_TOP_MAINPLL_D4_D8,
	CLK_TOP_UNIVPLL_D5_D8,
	CLK_TOP_TVDPLL1_D16
};

static const int atb_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_MAINPLL_D4_D2,
	CLK_TOP_MAINPLL_D5_D2
};

static const int sspm_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_MAINPLL_D7_D2,
	CLK_TOP_MAINPLL_D6_D2,
	CLK_TOP_MAINPLL_D5_D2,
	CLK_TOP_MAINPLL_D9,
	CLK_TOP_MAINPLL_D4_D2
};

static const int dp_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_TVDPLL1_D2,
	CLK_TOP_TVDPLL2_D2,
	CLK_TOP_TVDPLL1_D4,
	CLK_TOP_TVDPLL2_D4,
	CLK_TOP_TVDPLL1_D8,
	CLK_TOP_TVDPLL2_D8,
	CLK_TOP_TVDPLL1_D16,
	CLK_TOP_TVDPLL2_D16
};

static const int edp_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_TVDPLL1_D2,
	CLK_TOP_TVDPLL2_D2,
	CLK_TOP_TVDPLL1_D4,
	CLK_TOP_TVDPLL2_D4,
	CLK_TOP_TVDPLL1_D8,
	CLK_TOP_TVDPLL2_D8,
	CLK_TOP_TVDPLL1_D16,
	CLK_TOP_TVDPLL2_D16
};

static const int dpi_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_TVDPLL1_D2,
	CLK_TOP_TVDPLL2_D2,
	CLK_TOP_TVDPLL1_D4,
	CLK_TOP_TVDPLL2_D4,
	CLK_TOP_TVDPLL1_D8,
	CLK_TOP_TVDPLL2_D8,
	CLK_TOP_TVDPLL1_D16,
	CLK_TOP_TVDPLL2_D16
};

static const int disp_pwm0_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D6_D4,
	CLK_TOP_ULPOSC1_D2,
	CLK_TOP_ULPOSC1_D4,
	CLK_TOP_ULPOSC1_D16,
	CLK_TOP_ETHPLL_D4
};

static const int disp_pwm1_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D6_D4,
	CLK_TOP_ULPOSC1_D2,
	CLK_TOP_ULPOSC1_D4,
	CLK_TOP_ULPOSC1_D16
};

static const int usb_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D5_D4,
	CLK_TOP_UNIVPLL_D6_D4,
	CLK_TOP_UNIVPLL_D5_D2
};

static const int ssusb_xhci_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D5_D4,
	CLK_TOP_UNIVPLL_D6_D4,
	CLK_TOP_UNIVPLL_D5_D2
};

static const int usb_2p_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D5_D4,
	CLK_TOP_UNIVPLL_D6_D4,
	CLK_TOP_UNIVPLL_D5_D2
};

static const int ssusb_xhci_2p_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D5_D4,
	CLK_TOP_UNIVPLL_D6_D4,
	CLK_TOP_UNIVPLL_D5_D2
};

static const int usb_3p_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D5_D4,
	CLK_TOP_UNIVPLL_D6_D4,
	CLK_TOP_UNIVPLL_D5_D2
};

static const int ssusb_xhci_3p_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D5_D4,
	CLK_TOP_UNIVPLL_D6_D4,
	CLK_TOP_UNIVPLL_D5_D2
};

static const int i2c_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_MAINPLL_D4_D8,
	CLK_TOP_UNIVPLL_D5_D4
};

static const int seninf_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D4_D4,
	CLK_TOP_UNIVPLL_D6_D2,
	CLK_TOP_MAINPLL_D4_D2,
	CLK_TOP_UNIVPLL_D7,
	CLK_TOP_UNIVPLL_D6,
	CLK_TOP_MMPLL_D6,
	CLK_TOP_UNIVPLL_D5
};

static const int seninf1_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D4_D4,
	CLK_TOP_UNIVPLL_D6_D2,
	CLK_TOP_MAINPLL_D4_D2,
	CLK_TOP_UNIVPLL_D7,
	CLK_TOP_UNIVPLL_D6,
	CLK_TOP_MMPLL_D6,
	CLK_TOP_UNIVPLL_D5
};

static const int gcpu_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_MAINPLL_D6,
	CLK_TOP_UNIVPLL_D4_D2,
	CLK_TOP_MMPLL_D5_D2,
	CLK_TOP_UNIVPLL_D5_D2
};

static const int venc_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_MMPLL_D4_D2,
	CLK_TOP_MAINPLL_D6,
	CLK_TOP_UNIVPLL_D4_D2,
	CLK_TOP_MAINPLL_D4_D2,
	CLK_TOP_UNIVPLL_D6,
	CLK_TOP_MMPLL_D6,
	CLK_TOP_MAINPLL_D5_D2,
	CLK_TOP_MAINPLL_D6_D2,
	CLK_TOP_MMPLL_D9,
	CLK_TOP_UNIVPLL_D4_D4,
	CLK_TOP_MAINPLL_D4,
	CLK_TOP_UNIVPLL_D4,
	CLK_TOP_UNIVPLL_D5,
	CLK_TOP_UNIVPLL_D5_D2,
	CLK_TOP_MAINPLL_D5
};

static const int vdec_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_MAINPLL_D5_D2,
	CLK_TOP_MMPLL_D6_D2,
	CLK_TOP_UNIVPLL_D5_D2,
	CLK_TOP_UNIVPLL_D4_D2,
	CLK_TOP_MMPLL_D4_D2,
	CLK_TOP_UNIVPLL_D6,
	CLK_TOP_MAINPLL_D5,
	CLK_TOP_UNIVPLL_D5,
	CLK_TOP_MMPLL_D6,
	CLK_TOP_MAINPLL_D4,
	CLK_TOP_TVDPLL2,
	CLK_TOP_UNIVPLL_D4,
	CLK_TOP_IMGPLL,
	CLK_TOP_UNIVPLL_D6_D2,
	CLK_TOP_MMPLL_D9
};

static const int pwm_parents[] = {
	CLK_TOP_CLK32K,
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D4_D8,
	CLK_TOP_UNIVPLL_D6_D4
};

static const int mcupm_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_MAINPLL_D6_D2,
	CLK_TOP_MAINPLL_D7_D4
};

static const int spmi_p_mst_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_CLK13M,
	CLK_TOP_ULPOSC1_D8,
	CLK_TOP_ULPOSC1_D10,
	CLK_TOP_ULPOSC1_D16,
	CLK_TOP_ULPOSC1_D7,
	CLK_TOP_CLK32K,
	CLK_TOP_MAINPLL_D7_D8,
	CLK_TOP_MAINPLL_D6_D8,
	CLK_TOP_MAINPLL_D5_D8
};

static const int spmi_m_mst_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_CLK13M,
	CLK_TOP_ULPOSC1_D8,
	CLK_TOP_ULPOSC1_D10,
	CLK_TOP_ULPOSC1_D16,
	CLK_TOP_ULPOSC1_D7,
	CLK_TOP_CLK32K,
	CLK_TOP_MAINPLL_D7_D8,
	CLK_TOP_MAINPLL_D6_D8,
	CLK_TOP_MAINPLL_D5_D8
};

static const int dvfsrc_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_ULPOSC1_D10,
	CLK_TOP_UNIVPLL_D6_D8,
	CLK_TOP_MSDCPLL_D16
};

static const int tl_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D5_D4,
	CLK_TOP_MAINPLL_D4_D4
};

static const int aes_msdcfde_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_MAINPLL_D4_D2,
	CLK_TOP_MAINPLL_D6,
	CLK_TOP_MAINPLL_D4_D4,
	CLK_TOP_UNIVPLL_D4_D2,
	CLK_TOP_UNIVPLL_D6
};

static const int dsi_occ_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D6_D2,
	CLK_TOP_UNIVPLL_D5_D2,
	CLK_TOP_UNIVPLL_D4_D2
};

static const int wpe_vpp_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_MAINPLL_D5_D2,
	CLK_TOP_MMPLL_D6_D2,
	CLK_TOP_UNIVPLL_D5_D2,
	CLK_TOP_MAINPLL_D4_D2,
	CLK_TOP_UNIVPLL_D4_D2,
	CLK_TOP_MMPLL_D4_D2,
	CLK_TOP_MAINPLL_D6,
	CLK_TOP_MMPLL_D7,
	CLK_TOP_UNIVPLL_D6,
	CLK_TOP_MAINPLL_D5,
	CLK_TOP_UNIVPLL_D5,
	CLK_TOP_MAINPLL_D4,
	CLK_TOP_TVDPLL1,
	CLK_TOP_UNIVPLL_D4
};

static const int hdcp_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D4_D8,
	CLK_TOP_MAINPLL_D5_D8,
	CLK_TOP_UNIVPLL_D6_D4
};

static const int hdcp_24m_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_192M_D4,
	CLK_TOP_UNIVPLL_192M_D8,
	CLK_TOP_UNIVPLL_D6_D8
};

static const int hdmi_apb_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D6_D4,
	CLK_TOP_MSDCPLL_D2
};

static const int snps_eth_250m_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_ETHPLL_D2
};

static const int snps_eth_62p4m_ptp_parents[] = {
	CLK_TOP_APLL2_D3,
	CLK_TOP_APLL1_D3,
	CLK_TOP_CLK26M,
	CLK_TOP_ETHPLL_D8
};

static const int snps_eth_50m_rmii_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_ETHPLL_D10
};

static const int adsp_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_CLK13M,
	CLK_TOP_MAINPLL_D6,
	CLK_TOP_MAINPLL_D5_D2,
	CLK_TOP_UNIVPLL_D4_D4,
	CLK_TOP_UNIVPLL_D4,
	CLK_TOP_ULPOSC1_D2,
	CLK_TOP_ULPOSC1,
	CLK_TOP_ADSPPLL,
	CLK_TOP_ADSPPLL_D2,
	CLK_TOP_ADSPPLL_D4,
	CLK_TOP_ADSPPLL_D8
};

static const int audio_local_bus_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_CLK13M,
	CLK_TOP_MAINPLL_D4_D4,
	CLK_TOP_MAINPLL_D7_D2,
	CLK_TOP_MAINPLL_D5_D2,
	CLK_TOP_MAINPLL_D4_D2,
	CLK_TOP_MAINPLL_D7,
	CLK_TOP_MAINPLL_D4,
	CLK_TOP_UNIVPLL_D6,
	CLK_TOP_ULPOSC1,
	CLK_TOP_ULPOSC1_D4,
	CLK_TOP_ULPOSC1_D2
};

static const int asm_h_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D6_D4,
	CLK_TOP_UNIVPLL_D6_D2,
	CLK_TOP_MAINPLL_D5_D2
};

static const int asm_l_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_UNIVPLL_D6_D4,
	CLK_TOP_UNIVPLL_D6_D2,
	CLK_TOP_MAINPLL_D5_D2
};

static const int apll1_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_APLL1_D4
};

static const int apll2_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_APLL2_D4
};

static const int apll3_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_APLL3_D4
};

static const int apll4_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_APLL4_D4
};

static const int apll5_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_APLL5_D4
};

static const int i2so1_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_APLL1,
	CLK_TOP_APLL2,
	CLK_TOP_APLL3,
	CLK_TOP_APLL4,
	CLK_TOP_APLL5
};

static const int i2so2_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_APLL1,
	CLK_TOP_APLL2,
	CLK_TOP_APLL3,
	CLK_TOP_APLL4,
	CLK_TOP_APLL5
};

static const int i2si1_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_APLL1,
	CLK_TOP_APLL2,
	CLK_TOP_APLL3,
	CLK_TOP_APLL4,
	CLK_TOP_APLL5
};

static const int i2si2_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_APLL1,
	CLK_TOP_APLL2,
	CLK_TOP_APLL3,
	CLK_TOP_APLL4,
	CLK_TOP_APLL5
};

static const int dptx_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_APLL1,
	CLK_TOP_APLL2,
	CLK_TOP_APLL3,
	CLK_TOP_APLL4,
	CLK_TOP_APLL5
};

static const int aud_iec_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_APLL1,
	CLK_TOP_APLL2,
	CLK_TOP_APLL3,
	CLK_TOP_APLL4,
	CLK_TOP_APLL5
};

static const int a1sys_hp_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_APLL1_D4
};

static const int a2sys_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_APLL2_D4
};

static const int a3sys_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_APLL3_D4,
	CLK_TOP_APLL4_D4,
	CLK_TOP_APLL5_D4
};

static const int a4sys_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_APLL3_D4,
	CLK_TOP_APLL4_D4,
	CLK_TOP_APLL5_D4
};

static const int ecc_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_MAINPLL_D4_D4,
	CLK_TOP_MAINPLL_D5_D2,
	CLK_TOP_MAINPLL_D4_D2,
	CLK_TOP_MAINPLL_D6,
	CLK_TOP_UNIVPLL_D6
};

static const int spinor_parents[] = {
	CLK_TOP_CLK26M,
	CLK_TOP_CLK13M,
	CLK_TOP_MAINPLL_D7_D8,
	CLK_TOP_UNIVPLL_D6_D8
};

static const int ulposc_parents[] = {
	CLK_TOP_ULPOSC1,
	CLK_TOP_ETHPLL_D2,
	CLK_TOP_MAINPLL_D4_D2,
	CLK_TOP_ETHPLL_D10
};

static const int srck_parents[] = {
	CLK_TOP_ULPOSC1_D10,
	CLK_TOP_CLK26M
};

static const int mfg_fast_ref_parents[] = {
	CLK_TOP_MFG_CORE_TMP,
	CLK_TOP_MFGPLL
};

const struct mtk_composite top_muxes[] = {
	/*
	 * CLK_CFG_0
	 * axi_sel and bus_aximem_sel are bus clocks, should not be closed by Linux.
	 * spm_sel and scp_sel are main clocks in always-on co-processor.
	 */
	MUX_GATE(CLK_TOP_AXI, axi_parents, 0x020, 0, 4, 7),
	MUX_GATE(CLK_TOP_SPM, spm_parents, 0x020, 8, 4, 15),
	MUX_GATE(CLK_TOP_SCP, scp_parents, 0x020, 16, 4, 23),
	MUX_GATE(CLK_TOP_BUS_AXIMEM, bus_aximem_parents, 0x020, 24, 4, 31),
	/* CLK_CFG_1 */
	MUX_GATE(CLK_TOP_VPP, vpp_parents, 0x02C, 0, 4, 7),
	MUX_GATE(CLK_TOP_ETHDR, ethdr_parents, 0x02C, 8, 4, 15),
	MUX_GATE(CLK_TOP_IPE, ipe_parents, 0x02C, 16, 4, 23),
	MUX_GATE(CLK_TOP_CAM, cam_parents, 0x02C, 24, 4, 31),
	/* CLK_CFG_2 */
	MUX_GATE(CLK_TOP_CCU, ccu_parents, 0x038, 0, 4, 7),
	MUX_GATE(CLK_TOP_CCU_AHB, ccu_ahb_parents, 0x038, 8, 4, 15),
	MUX_GATE(CLK_TOP_IMG, img_parents, 0x038, 16, 4, 23),
	MUX_GATE(CLK_TOP_CAMTM, camtm_parents, 0x038, 24, 4, 31),
	/* CLK_CFG_3 */
	MUX_GATE(CLK_TOP_DSP, dsp_parents, 0x044, 0, 4, 7),
	MUX_GATE(CLK_TOP_DSP1, dsp1_parents, 0x044, 8, 4, 15),
	MUX_GATE(CLK_TOP_DSP2, dsp2_parents, 0x044, 16, 4, 23),
	MUX_GATE(CLK_TOP_DSP3, dsp3_parents, 0x044, 24, 4, 31),
	/* CLK_CFG_4 */
	MUX_GATE(CLK_TOP_DSP4, dsp4_parents, 0x050, 0, 4, 7),
	MUX_GATE(CLK_TOP_DSP5, dsp5_parents, 0x050, 8, 4, 15),
	MUX_GATE(CLK_TOP_DSP6, dsp6_parents, 0x050, 16, 4, 23),
	MUX_GATE(CLK_TOP_DSP7, dsp7_parents, 0x050, 24, 4, 31),
	/* CLK_CFG_5 */
	MUX_GATE(CLK_TOP_MFG_CORE_TMP, mfg_core_tmp_parents, 0x05C, 0, 4, 7),
	MUX_GATE(CLK_TOP_CAMTG, camtg_parents, 0x05C, 8, 4, 15),
	MUX_GATE(CLK_TOP_CAMTG2, camtg2_parents, 0x05C, 16, 4, 23),
	MUX_GATE(CLK_TOP_CAMTG3, camtg3_parents, 0x05C, 24, 4, 31),
	/* CLK_CFG_6 */
	MUX_GATE(CLK_TOP_UART, uart_parents, 0x068, 0, 4, 7),
	MUX_GATE(CLK_TOP_SPI, spi_parents, 0x068, 8, 4, 15),
	MUX_GATE(CLK_TOP_MSDC50_0_HCLK, msdc5hclk_parents, 0x068, 16, 4, 23),
	MUX_GATE(CLK_TOP_MSDC50_0, msdc50_0_parents, 0x068, 24, 4, 31),
	/* CLK_CFG_7 */
	MUX_GATE(CLK_TOP_MSDC30_1, msdc30_1_parents, 0x074, 0, 4, 7),
	MUX_GATE(CLK_TOP_MSDC30_2, msdc30_2_parents, 0x074, 8, 4, 15),
	MUX_GATE(CLK_TOP_INTDIR, intdir_parents, 0x074, 16, 4, 23),
	MUX_GATE(CLK_TOP_AUD_INTBUS, aud_intbus_parents, 0x074, 24, 4, 31),
	/* CLK_CFG_8 */
	MUX_GATE(CLK_TOP_AUDIO_H, audio_h_parents, 0x080, 0, 4, 7),
	MUX_GATE(CLK_TOP_PWRAP_ULPOSC, pwrap_ulposc_parents, 0x080, 8, 4, 15),
	MUX_GATE(CLK_TOP_ATB, atb_parents, 0x080, 16, 4, 23),
	MUX_GATE(CLK_TOP_SSPM, sspm_parents, 0x080, 24, 4, 31),
	/* CLK_CFG_9 */
	MUX_GATE(CLK_TOP_DP, dp_parents, 0x08C, 0, 4, 7),
	MUX_GATE(CLK_TOP_EDP, edp_parents, 0x08C, 8, 4, 15),
	MUX_GATE(CLK_TOP_DPI, dpi_parents, 0x08C, 16, 4, 23),
	MUX_GATE(CLK_TOP_DISP_PWM0, disp_pwm0_parents, 0x08C, 24, 4, 31),
	/* CLK_CFG_10 */
	MUX_GATE(CLK_TOP_DISP_PWM1, disp_pwm1_parents, 0x098, 0, 4, 7),
	MUX_GATE(CLK_TOP_USB_TOP, usb_parents, 0x098, 8, 4, 15),
	MUX_GATE(CLK_TOP_SSUSB_XHCI, ssusb_xhci_parents, 0x098, 16, 4, 23),
	MUX_GATE(CLK_TOP_USB_TOP_2P, usb_2p_parents, 0x098, 24, 4, 31),
	/* CLK_CFG_11 */
	MUX_GATE(CLK_TOP_SSUSB_XHCI_2P, ssusb_xhci_2p_parents, 0x0A4, 0, 4, 7),
	MUX_GATE(CLK_TOP_USB_TOP_3P, usb_3p_parents, 0x0A4, 8, 4, 15),
	MUX_GATE(CLK_TOP_SSUSB_XHCI_3P, ssusb_xhci_3p_parents, 0x0A4, 16, 4, 23),
	MUX_GATE(CLK_TOP_I2C, i2c_parents, 0x0A4, 24, 4, 31),
	/* CLK_CFG_12 */
	MUX_GATE(CLK_TOP_SENINF, seninf_parents, 0x0B0, 0, 4, 7),
	MUX_GATE(CLK_TOP_SENINF1, seninf1_parents, 0x0B0, 8, 4, 15),
	MUX_GATE(CLK_TOP_GCPU, gcpu_parents, 0x0B0, 16, 4, 23),
	MUX_GATE(CLK_TOP_VENC, venc_parents, 0x0B0, 24, 4, 31),
	/*
	 * CLK_CFG_13
	 * top_mcupm is main clock in co-processor, should not be handled by Linux.
	 */
	MUX_GATE(CLK_TOP_VDEC, vdec_parents, 0x0BC, 0, 4, 7),
	MUX_GATE(CLK_TOP_PWM, pwm_parents, 0x0BC, 8, 4, 15),
	MUX_GATE(CLK_TOP_MCUPM, mcupm_parents, 0x0BC, 16, 4, 23),
	MUX_GATE(CLK_TOP_SPMI_P_MST, spmi_p_mst_parents, 0x0BC, 24, 4, 31),
	/*
	 * CLK_CFG_14
	 * dvfsrc_sel is for internal DVFS usage, should not be handled by Linux.
	 */
	MUX_GATE(CLK_TOP_SPMI_M_MST, spmi_m_mst_parents, 0x0C8, 0, 4, 7),
	MUX_GATE(CLK_TOP_DVFSRC, dvfsrc_parents, 0x0C8, 8, 4, 15),
	MUX_GATE(CLK_TOP_TL, tl_parents, 0x0C8, 16, 4, 23),
	MUX_GATE(CLK_TOP_AES_MSDCFDE, aes_msdcfde_parents, 0x0C8, 24, 4, 31),
	/* CLK_CFG_15 */
	MUX_GATE(CLK_TOP_DSI_OCC, dsi_occ_parents, 0x0D4, 0, 4, 7),
	MUX_GATE(CLK_TOP_WPE_VPP, wpe_vpp_parents, 0x0D4, 8, 4, 15),
	MUX_GATE(CLK_TOP_HDCP, hdcp_parents, 0x0D4, 16, 4, 23),
	MUX_GATE(CLK_TOP_HDCP_24M, hdcp_24m_parents, 0x0D4, 24, 4, 31),
	/* CLK_CFG_16 */
	MUX_GATE(CLK_TOP_HDMI_APB, hdmi_apb_parents, 0x0E0, 0, 4, 7),
	MUX_GATE(CLK_TOP_SNPS_ETH_250M, snps_eth_250m_parents, 0x0E0, 8, 4, 15),
	MUX_GATE(CLK_TOP_SNPS_ETH_62P4M_PTP, snps_eth_62p4m_ptp_parents, 0x0E0, 16, 4, 23),
	MUX_GATE(CLK_TOP_SNPS_ETH_50M_RMII, snps_eth_50m_rmii_parents, 0x0E0, 24, 4, 31),
	/* CLK_CFG_17 */
	MUX_GATE(CLK_TOP_ADSP, adsp_parents, 0x0EC, 0, 4, 7),
	MUX_GATE(CLK_TOP_AUDIO_LOCAL_BUS, audio_local_bus_parents, 0x0EC, 8, 4, 15),
	MUX_GATE(CLK_TOP_ASM_H, asm_h_parents, 0x0EC, 16, 4, 23),
	MUX_GATE(CLK_TOP_ASM_L, asm_l_parents, 0x0EC, 24, 4, 31),
	/* CLK_CFG_18 */
	MUX_GATE(CLK_TOP_APLL1, apll1_parents, 0x0F8, 0, 4, 7),
	MUX_GATE(CLK_TOP_APLL2, apll2_parents, 0x0F8, 8, 4, 15),
	MUX_GATE(CLK_TOP_APLL3, apll3_parents, 0x0F8, 16, 4, 23),
	MUX_GATE(CLK_TOP_APLL4, apll4_parents, 0x0F8, 24, 4, 31),
	/* CLK_CFG_19 */
	MUX_GATE(CLK_TOP_APLL5, apll5_parents, 0x0104, 0, 4, 7),
	MUX_GATE(CLK_TOP_I2SO1, i2so1_parents, 0x0104, 8, 4, 15),
	MUX_GATE(CLK_TOP_I2SO2, i2so2_parents, 0x0104, 16, 4, 23),
	MUX_GATE(CLK_TOP_I2SI1, i2si1_parents, 0x0104, 24, 4, 31),
	/* CLK_CFG_20 */
	MUX_GATE(CLK_TOP_I2SI2, i2si2_parents, 0x0110, 0, 4, 7),
	MUX_GATE(CLK_TOP_DPTX, dptx_parents, 0x0110, 8, 4, 15),
	MUX_GATE(CLK_TOP_AUD_IEC, aud_iec_parents, 0x0110, 16, 4, 23),
	MUX_GATE(CLK_TOP_A1SYS_HP, a1sys_hp_parents, 0x0110, 24, 4, 31),
	/* CLK_CFG_21 */
	MUX_GATE(CLK_TOP_A2SYS, a2sys_parents, 0x011C, 0, 4, 7),
	MUX_GATE(CLK_TOP_A3SYS, a3sys_parents, 0x011C, 8, 4, 15),
	MUX_GATE(CLK_TOP_A4SYS, a4sys_parents, 0x011C, 16, 4, 23),
	MUX_GATE(CLK_TOP_ECC, ecc_parents, 0x011C, 24, 4, 31),
	/*
	 * CLK_CFG_22
	 * top_ulposc/top_srck are clock source of always on co-processor,
	 * should not be closed by Linux.
	 */
	MUX_GATE(CLK_TOP_SPINOR, spinor_parents, 0x0128, 0, 4, 7),
	MUX_GATE(CLK_TOP_ULPOSC, ulposc_parents, 0x0128, 8, 4, 15),
	MUX_GATE(CLK_TOP_SRCK, srck_parents, 0x0128, 16, 4, 23),
};

static const struct mtk_gate_regs top0_cg_regs = {
	.set_ofs = 0x238,
	.clr_ofs = 0x238,
	.sta_ofs = 0x238,
};

static const struct mtk_gate_regs top1_cg_regs = {
	.set_ofs = 0x250,
	.clr_ofs = 0x250,
	.sta_ofs = 0x250,
};

#define GATE_TOP0(_id, _parent, _shift)			\
	GATE_MTK_FLAGS(_id, _parent, &top0_cg_regs, _shift,	\
		CLK_GATE_NO_SETCLR_INV | CLK_PARENT_TOPCKGEN)

#define GATE_TOP1(_id, _parent, _shift)			\
	GATE_MTK_FLAGS(_id, _parent, &top1_cg_regs, _shift, \
		CLK_GATE_NO_SETCLR_INV | CLK_PARENT_TOPCKGEN)

static const struct mtk_gate top_clks[] = {
	/* TOP0 */
	GATE_TOP0(CLK_TOP_CFGREG_CLOCK_EN_VPP0, CLK_TOP_VPP, 0),
	GATE_TOP0(CLK_TOP_CFGREG_CLOCK_EN_VPP1, CLK_TOP_VPP, 1),
	GATE_TOP0(CLK_TOP_CFGREG_CLOCK_EN_VDO0, CLK_TOP_VPP, 2),
	GATE_TOP0(CLK_TOP_CFGREG_CLOCK_EN_VDO1, CLK_TOP_VPP, 3),
	GATE_TOP0(CLK_TOP_CFGREG_CLOCK_ISP_AXI_GALS, CLK_TOP_VPP, 4),
	GATE_TOP0(CLK_TOP_CFGREG_F26M_VPP0, CLK_TOP_CLK26M, 5),
	GATE_TOP0(CLK_TOP_CFGREG_F26M_VPP1, CLK_TOP_CLK26M, 6),
	GATE_TOP0(CLK_TOP_CFGREG_F26M_VDO0, CLK_TOP_CLK26M, 7),
	GATE_TOP0(CLK_TOP_CFGREG_F26M_VDO1, CLK_TOP_CLK26M, 8),
	GATE_TOP0(CLK_TOP_CFGREG_AUD_F26M_AUD, CLK_TOP_CLK26M, 9),
	GATE_TOP0(CLK_TOP_CFGREG_UNIPLL_SES, CLK_TOP_UNIVPLL_D2, 15),
	GATE_TOP0(CLK_TOP_CFGREG_F_PCIE_PHY_REF, CLK_TOP_CLK26M, 18),
	/* TOP1 */
	GATE_TOP1(CLK_TOP_SSUSB_TOP_REF, CLK_TOP_CLK26M, 0),
	GATE_TOP1(CLK_TOP_SSUSB_PHY_REF, CLK_TOP_CLK26M, 1),
	GATE_TOP1(CLK_TOP_SSUSB_TOP_P1_REF, CLK_TOP_CLK26M, 2),
	GATE_TOP1(CLK_TOP_SSUSB_PHY_P1_REF, CLK_TOP_CLK26M, 3),
	GATE_TOP1(CLK_TOP_SSUSB_TOP_P2_REF, CLK_TOP_CLK26M, 4),
	GATE_TOP1(CLK_TOP_SSUSB_PHY_P2_REF, CLK_TOP_CLK26M, 5),
	GATE_TOP1(CLK_TOP_SSUSB_TOP_P3_REF, CLK_TOP_CLK26M, 6),
	GATE_TOP1(CLK_TOP_SSUSB_PHY_P3_REF, CLK_TOP_CLK26M, 7),
};

static const struct mtk_gate_regs apmixed_cg_regs = {
	.set_ofs = 0x8,
	.clr_ofs = 0x8,
	.sta_ofs = 0x8,
};

#define MT8188_PLL_FMAX		(3800UL * MHZ)
#define MT8188_PLL_FMIN		(1500UL * MHZ)
#define MT8188_INTEGER_BITS	8

#define PLL(_id, _name, _reg, _pwr_reg, _en_mask, _flags,		\
	    _rst_bar_mask, _pcwbits, _pd_reg, _pd_shift,		\
	    _tuner_reg, _tuner_en_reg, _tuner_en_bit,			\
	    _pcw_reg, _pcw_shift, _pcw_chg_reg,				\
	    _en_reg, _pll_en_bit) {					\
		.id = _id,						\
		.reg = _reg,						\
		.pwr_reg = _pwr_reg,					\
		.en_mask = _en_mask,					\
		.rst_bar_mask = _rst_bar_mask,				\
		.fmax = MT8188_PLL_FMAX,				\
		.fmin = MT8188_PLL_FMIN,				\
		.flags = _flags,					\
		.pcwbits = _pcwbits,					\
		.pcwibits = MT8188_INTEGER_BITS,			\
		.pd_reg = _pd_reg,					\
		.pd_shift = _pd_shift,					\
		.pcw_reg = _pcw_reg,					\
		.pcw_shift = _pcw_shift,				\
		.pcw_chg_reg = _pcw_chg_reg,				\
	}

const struct mtk_pll_data apmixed_plls[] = {
	PLL(CLK_APMIXED_ETHPLL, "ethpll", 0x044C, 0x0458, 0,
	    0, 0, 22, 0x0450, 24, 0, 0, 0, 0x0450, 0, 0, 0, 9),
	PLL(CLK_APMIXED_MSDCPLL, "msdcpll", 0x0514, 0x0520, 0,
	    0, 0, 22, 0x0518, 24, 0, 0, 0, 0x0518, 0, 0, 0, 9),
	PLL(CLK_APMIXED_TVDPLL1, "tvdpll1", 0x0524, 0x0530, 0,
	    0, 0, 22, 0x0528, 24, 0, 0, 0, 0x0528, 0, 0, 0, 9),
	PLL(CLK_APMIXED_TVDPLL2, "tvdpll2", 0x0534, 0x0540, 0,
	    0, 0, 22, 0x0538, 24, 0, 0, 0, 0x0538, 0, 0, 0, 9),
	PLL(CLK_APMIXED_MMPLL, "mmpll", 0x0544, 0x0550, 0xff000000,
	    HAVE_RST_BAR, BIT(23), 22, 0x0548, 24, 0, 0, 0, 0x0548, 0, 0, 0, 9),
	PLL(CLK_APMIXED_MAINPLL, "mainpll", 0x045C, 0x0468, 0xff000000,
	    HAVE_RST_BAR, BIT(23), 22, 0x0460, 24, 0, 0, 0, 0x0460, 0, 0, 0, 9),
	PLL(CLK_APMIXED_IMGPLL, "imgpll", 0x0554, 0x0560, 0,
	    0, 0, 22, 0x0558, 24, 0, 0, 0, 0x0558, 0, 0, 0, 9),
	PLL(CLK_APMIXED_UNIVPLL, "univpll", 0x0504, 0x0510, 0xff000000,
	    HAVE_RST_BAR, BIT(23), 22, 0x0508, 24, 0, 0, 0, 0x0508, 0, 0, 0, 9),
	PLL(CLK_APMIXED_ADSPPLL, "adsppll", 0x042C, 0x0438, 0,
	    0, 0, 22, 0x0430, 24, 0, 0, 0, 0x0430, 0, 0, 0, 9),
	PLL(CLK_APMIXED_APLL1, "apll1", 0x0304, 0x0314, 0,
	    0, 0, 32, 0x0308, 24, 0x0034, 0x0000, 12, 0x030C, 0, 0, 0, 9),
	PLL(CLK_APMIXED_APLL2, "apll2", 0x0318, 0x0328, 0,
	    0, 0, 32, 0x031C, 24, 0x0038, 0x0000, 13, 0x0320, 0, 0, 0, 9),
	PLL(CLK_APMIXED_APLL3, "apll3", 0x032C, 0x033C, 0,
	    0, 0, 32, 0x0330, 24, 0x003C, 0x0000, 14, 0x0334, 0, 0, 0, 9),
	PLL(CLK_APMIXED_APLL4, "apll4", 0x0404, 0x0414, 0,
	    0, 0, 32, 0x0408, 24, 0x0040, 0x0000, 15, 0x040C, 0, 0, 0, 9),
	PLL(CLK_APMIXED_APLL5, "apll5", 0x0418, 0x0428, 0,
	    0, 0, 32, 0x041C, 24, 0x0044, 0x0000, 16, 0x0420, 0, 0, 0, 9),
	PLL(CLK_APMIXED_MFGPLL, "mfgpll", 0x0340, 0x034C, 0,
	    0, 0, 22, 0x0344, 24, 0, 0, 0, 0x0344, 0, 0, 0, 9),
};

static const struct mtk_gate_regs infra_ao0_cg_regs = {
	.set_ofs = 0x80,
	.clr_ofs = 0x84,
	.sta_ofs = 0x90,
};

static const struct mtk_gate_regs infra_ao1_cg_regs = {
	.set_ofs = 0x88,
	.clr_ofs = 0x8c,
	.sta_ofs = 0x94,
};

static const struct mtk_gate_regs infra_ao2_cg_regs = {
	.set_ofs = 0xa4,
	.clr_ofs = 0xa8,
	.sta_ofs = 0xac,
};

static const struct mtk_gate_regs infra_ao3_cg_regs = {
	.set_ofs = 0xc0,
	.clr_ofs = 0xc4,
	.sta_ofs = 0xc8,
};

static const struct mtk_gate_regs infra_ao4_cg_regs = {
	.set_ofs = 0xe0,
	.clr_ofs = 0xe4,
	.sta_ofs = 0xe8,
};

#define GATE_INFRA_AO0(_id, _parent, _shift)			\
	GATE_MTK_FLAGS(_id, _parent, &infra_ao0_cg_regs, _shift,\
		CLK_PARENT_TOPCKGEN | CLK_GATE_SETCLR)

#define GATE_INFRA_AO1(_id, _parent, _shift)			\
	GATE_MTK_FLAGS(_id, _parent, &infra_ao1_cg_regs, _shift,\
		CLK_PARENT_TOPCKGEN | CLK_GATE_SETCLR)

#define GATE_INFRA_AO2(_id, _parent, _shift)			\
	GATE_MTK_FLAGS(_id, _parent, &infra_ao2_cg_regs, _shift,\
		CLK_PARENT_TOPCKGEN | CLK_GATE_SETCLR)

#define GATE_INFRA_AO3(_id, _parent, _shift)			\
	GATE_MTK_FLAGS(_id, _parent, &infra_ao3_cg_regs, _shift,\
		CLK_PARENT_TOPCKGEN | CLK_GATE_SETCLR)

#define GATE_INFRA_AO4(_id, _parent, _shift)			\
	GATE_MTK_FLAGS(_id, _parent, &infra_ao4_cg_regs, _shift,\
		CLK_PARENT_TOPCKGEN | CLK_GATE_SETCLR)

static const struct mtk_gate infra_ao_clks[] = {
	/* INFRA_AO0 */
	GATE_INFRA_AO0(CLK_INFRA_AO_PMIC_TMR, CLK_TOP_PWRAP_ULPOSC, 0),
	GATE_INFRA_AO0(CLK_INFRA_AO_PMIC_AP, CLK_TOP_PWRAP_ULPOSC, 1),
	GATE_INFRA_AO0(CLK_INFRA_AO_PMIC_MD, CLK_TOP_PWRAP_ULPOSC, 2),
	GATE_INFRA_AO0(CLK_INFRA_AO_PMIC_CONN, CLK_TOP_PWRAP_ULPOSC, 3),
	/* infra_ao_sej is main clock is for secure engine with JTAG support */
	GATE_INFRA_AO0(CLK_INFRA_AO_SEJ, CLK_TOP_AXI, 5),
	GATE_INFRA_AO0(CLK_INFRA_AO_APXGPT, CLK_TOP_AXI, 6),
	GATE_INFRA_AO0(CLK_INFRA_AO_GCE, CLK_TOP_AXI, 8),
	GATE_INFRA_AO0(CLK_INFRA_AO_GCE2, CLK_TOP_AXI, 9),
	GATE_INFRA_AO0(CLK_INFRA_AO_THERM, CLK_TOP_AXI, 10),
	GATE_INFRA_AO0(CLK_INFRA_AO_PWM_HCLK, CLK_TOP_AXI, 15),
	GATE_INFRA_AO0(CLK_INFRA_AO_PWM1, CLK_TOP_PWM, 16),
	GATE_INFRA_AO0(CLK_INFRA_AO_PWM2, CLK_TOP_PWM, 17),
	GATE_INFRA_AO0(CLK_INFRA_AO_PWM3, CLK_TOP_PWM, 18),
	GATE_INFRA_AO0(CLK_INFRA_AO_PWM4, CLK_TOP_PWM, 19),
	GATE_INFRA_AO0(CLK_INFRA_AO_PWM, CLK_TOP_PWM, 21),
	GATE_INFRA_AO0(CLK_INFRA_AO_UART0, CLK_TOP_UART, 22),
	GATE_INFRA_AO0(CLK_INFRA_AO_UART1, CLK_TOP_UART, 23),
	GATE_INFRA_AO0(CLK_INFRA_AO_UART2, CLK_TOP_UART, 24),
	GATE_INFRA_AO0(CLK_INFRA_AO_UART3, CLK_TOP_UART, 25),
	GATE_INFRA_AO0(CLK_INFRA_AO_UART4, CLK_TOP_UART, 26),
	GATE_INFRA_AO0(CLK_INFRA_AO_GCE_26M, CLK_TOP_CLK26M, 27),
	GATE_INFRA_AO0(CLK_INFRA_AO_CQ_DMA_FPC, CLK_TOP_PAD_FPC, 28),
	GATE_INFRA_AO0(CLK_INFRA_AO_UART5, CLK_TOP_UART, 29),
	/* INFRA_AO1 */
	GATE_INFRA_AO1(CLK_INFRA_AO_HDMI_26M, CLK_TOP_CLK26M, 0),
	GATE_INFRA_AO1(CLK_INFRA_AO_SPI0, CLK_TOP_SPI, 1),
	GATE_INFRA_AO1(CLK_INFRA_AO_MSDC0, CLK_TOP_MSDC50_0_HCLK, 2),
	GATE_INFRA_AO1(CLK_INFRA_AO_MSDC1, CLK_TOP_AXI, 4),
	GATE_INFRA_AO1(CLK_INFRA_AO_MSDC2, CLK_TOP_AXI, 5),
	GATE_INFRA_AO1(CLK_INFRA_AO_MSDC0_SRC, CLK_TOP_MSDC50_0, 6),
	/* infra_ao_dvfsrc is for internal DVFS usage, should not be handled by Linux. */
	GATE_INFRA_AO1(CLK_INFRA_AO_DVFSRC, CLK_TOP_CLK26M, 7),
	GATE_INFRA_AO1(CLK_INFRA_AO_TRNG, CLK_TOP_AXI, 9),
	GATE_INFRA_AO1(CLK_INFRA_AO_AUXADC, CLK_TOP_CLK26M, 10),
	GATE_INFRA_AO1(CLK_INFRA_AO_CPUM, CLK_TOP_AXI, 11),
	GATE_INFRA_AO1(CLK_INFRA_AO_HDMI_32K, CLK_TOP_CLK32K, 12),
	GATE_INFRA_AO1(CLK_INFRA_AO_CEC_66M_HCLK, CLK_TOP_AXI, 13),
	GATE_INFRA_AO1(CLK_INFRA_AO_PCIE_TL_26M, CLK_TOP_CLK26M, 15),
	GATE_INFRA_AO1(CLK_INFRA_AO_MSDC1_SRC, CLK_TOP_MSDC30_1, 16),
	GATE_INFRA_AO1(CLK_INFRA_AO_CEC_66M_BCLK, CLK_TOP_AXI, 17),
	GATE_INFRA_AO1(CLK_INFRA_AO_PCIE_TL_96M, CLK_TOP_TL, 18),
	/* infra_ao_dapc is for device access permission control module */
	GATE_INFRA_AO1(CLK_INFRA_AO_DEVICE_APC, CLK_TOP_AXI, 20),
	GATE_INFRA_AO1(CLK_INFRA_AO_ECC_66M_HCLK, CLK_TOP_AXI, 23),
	GATE_INFRA_AO1(CLK_INFRA_AO_DEBUGSYS, CLK_TOP_AXI, 24),
	GATE_INFRA_AO1(CLK_INFRA_AO_AUDIO, CLK_TOP_AXI, 25),
	GATE_INFRA_AO1(CLK_INFRA_AO_PCIE_TL_32K, CLK_TOP_CLK32K, 26),
	GATE_INFRA_AO1(CLK_INFRA_AO_DBG_TRACE, CLK_TOP_AXI, 29),
	GATE_INFRA_AO1(CLK_INFRA_AO_DRAMC_F26M, CLK_TOP_CLK26M, 31),
	/* INFRA_AO2 */
	GATE_INFRA_AO2(CLK_INFRA_AO_IRTX, CLK_TOP_AXI, 0),
	GATE_INFRA_AO2(CLK_INFRA_AO_DISP_PWM, CLK_TOP_DISP_PWM0, 2),
	GATE_INFRA_AO2(CLK_INFRA_AO_CLDMA_BCLK, CLK_TOP_AXI, 3),
	GATE_INFRA_AO2(CLK_INFRA_AO_AUDIO_26M_BCLK, CLK_TOP_CLK26M, 4),
	GATE_INFRA_AO2(CLK_INFRA_AO_SPI1, CLK_TOP_SPI, 6),
	GATE_INFRA_AO2(CLK_INFRA_AO_SPI2, CLK_TOP_SPI, 9),
	GATE_INFRA_AO2(CLK_INFRA_AO_SPI3, CLK_TOP_SPI, 10),
	GATE_INFRA_AO2(CLK_INFRA_AO_FSSPM, CLK_TOP_SSPM, 15),
	GATE_INFRA_AO2(CLK_INFRA_AO_SSPM_BUS_HCLK, CLK_TOP_AXI, 17),
	GATE_INFRA_AO2(CLK_INFRA_AO_APDMA_BCLK, CLK_TOP_AXI, 18),
	GATE_INFRA_AO2(CLK_INFRA_AO_SPI4, CLK_TOP_SPI, 25),
	GATE_INFRA_AO2(CLK_INFRA_AO_SPI5, CLK_TOP_SPI, 26),
	GATE_INFRA_AO2(CLK_INFRA_AO_CQ_DMA, CLK_TOP_AXI, 27),
	/* INFRA_AO3 */
	GATE_INFRA_AO3(CLK_INFRA_AO_MSDC0_SELF, CLK_TOP_MSDC50_0, 0),
	GATE_INFRA_AO3(CLK_INFRA_AO_MSDC1_SELF, CLK_TOP_MSDC50_0, 1),
	GATE_INFRA_AO3(CLK_INFRA_AO_MSDC2_SELF, CLK_TOP_MSDC50_0, 2),
	GATE_INFRA_AO3(CLK_INFRA_AO_I2S_DMA, CLK_TOP_AXI, 5),
	GATE_INFRA_AO3(CLK_INFRA_AO_AP_MSDC0, CLK_TOP_MSDC50_0, 7),
	GATE_INFRA_AO3(CLK_INFRA_AO_MD_MSDC0, CLK_TOP_MSDC50_0, 8),
	GATE_INFRA_AO3(CLK_INFRA_AO_MSDC30_2, CLK_TOP_MSDC30_2, 9),
	GATE_INFRA_AO3(CLK_INFRA_AO_GCPU, CLK_TOP_GCPU, 10),
	GATE_INFRA_AO3(CLK_INFRA_AO_PCIE_PERI_26M, CLK_TOP_CLK26M, 15),
	GATE_INFRA_AO3(CLK_INFRA_AO_GCPU_66M_BCLK, CLK_TOP_AXI, 16),
	GATE_INFRA_AO3(CLK_INFRA_AO_GCPU_133M_BCLK, CLK_TOP_AXI, 17),
	GATE_INFRA_AO3(CLK_INFRA_AO_DISP_PWM1, CLK_TOP_DISP_PWM1, 20),
	GATE_INFRA_AO3(CLK_INFRA_AO_FBIST2FPC, CLK_TOP_MSDC50_0, 24),
	/* infra_ao_dapc_sync is for device access permission control module */
	GATE_INFRA_AO3(CLK_INFRA_AO_DEVICE_APC_SYNC, CLK_TOP_AXI, 25),
	GATE_INFRA_AO3(CLK_INFRA_AO_PCIE_P1_PERI_26M, CLK_TOP_CLK26M, 26),
	/* INFRA_AO4 */
	/* infra_ao_133m_mclk_set/infra_ao_66m_mclk_set are main clocks of peripheral */
	GATE_INFRA_AO4(CLK_INFRA_AO_133M_MCLK_CK, CLK_TOP_AXI, 0),
	GATE_INFRA_AO4(CLK_INFRA_AO_66M_MCLK_CK, CLK_TOP_AXI, 1),
	GATE_INFRA_AO4(CLK_INFRA_AO_PCIE_PL_P_250M_P0, CLK_TOP_PEXTP_PIPE, 7),
	GATE_INFRA_AO4(CLK_INFRA_AO_RG_AES_MSDCFDE_CK_0P, CLK_TOP_AES_MSDCFDE, 18),
};

static const struct mtk_gate_regs peri_ao_cg_regs = {
	.set_ofs = 0x10,
	.clr_ofs = 0x14,
	.sta_ofs = 0x18,
};

#define GATE_PERI_AO(_id, _parent, _shift)			\
	GATE_MTK_FLAGS(_id, _parent, &peri_ao_cg_regs, _shift,	\
		       CLK_PARENT_TOPCKGEN | CLK_GATE_SETCLR)

static const struct mtk_gate peri_ao_clks[] = {
	GATE_PERI_AO(CLK_PERI_AO_ETHERNET, CLK_TOP_AXI, 0),
	GATE_PERI_AO(CLK_PERI_AO_ETHERNET_BUS, CLK_TOP_AXI, 1),
	GATE_PERI_AO(CLK_PERI_AO_FLASHIF_BUS, CLK_TOP_AXI, 3),
	GATE_PERI_AO(CLK_PERI_AO_FLASHIF_26M, CLK_TOP_CLK26M, 4),
	GATE_PERI_AO(CLK_PERI_AO_FLASHIFLASHCK, CLK_TOP_SPINOR, 5),
	GATE_PERI_AO(CLK_PERI_AO_SSUSB_2P_BUS, CLK_TOP_USB_TOP_2P, 9),
	GATE_PERI_AO(CLK_PERI_AO_SSUSB_2P_XHCI, CLK_TOP_SSUSB_XHCI_2P, 10),
	GATE_PERI_AO(CLK_PERI_AO_SSUSB_3P_BUS, CLK_TOP_USB_TOP_3P, 11),
	GATE_PERI_AO(CLK_PERI_AO_SSUSB_3P_XHCI, CLK_TOP_SSUSB_XHCI_3P, 12),
	GATE_PERI_AO(CLK_PERI_AO_SSUSB_BUS, CLK_TOP_USB_TOP, 13),
	GATE_PERI_AO(CLK_PERI_AO_SSUSB_XHCI, CLK_TOP_SSUSB_XHCI, 14),
	GATE_PERI_AO(CLK_PERI_AO_ETHERNET_MAC, CLK_TOP_SNPS_ETH_250M, 16),
	GATE_PERI_AO(CLK_PERI_AO_PCIE_P0_FMEM, CLK_TOP_466M_FMEM, 24),
};

static const struct mtk_gate_regs imp_iic_wrap_cg_regs = {
	.set_ofs = 0xe08,
	.clr_ofs = 0xe04,
	.sta_ofs = 0xe00,
};

#define GATE_IMP_IIC_WRAP(_id, _parent, _shift)				\
	GATE_MTK_FLAGS(_id, _parent, &imp_iic_wrap_cg_regs, _shift,	\
		CLK_PARENT_TOPCKGEN | CLK_GATE_SETCLR)

static const struct mtk_gate imp_iic_wrap_c_clks[] = {
	GATE_IMP_IIC_WRAP(CLK_IMP_IIC_WRAP_C_AP_CLOCK_I2C0, CLK_TOP_I2C, 0),
	GATE_IMP_IIC_WRAP(CLK_IMP_IIC_WRAP_C_AP_CLOCK_I2C2, CLK_TOP_I2C, 1),
	GATE_IMP_IIC_WRAP(CLK_IMP_IIC_WRAP_C_AP_CLOCK_I2C3, CLK_TOP_I2C, 2),
};

static const struct mtk_gate imp_iic_wrap_w_clks[] = {
	GATE_IMP_IIC_WRAP(CLK_IMP_IIC_WRAP_W_AP_CLOCK_I2C1, CLK_TOP_I2C, 0),
	GATE_IMP_IIC_WRAP(CLK_IMP_IIC_WRAP_W_AP_CLOCK_I2C4, CLK_TOP_I2C, 1),
};

static const struct mtk_gate imp_iic_wrap_en_clks[] = {
	GATE_IMP_IIC_WRAP(CLK_IMP_IIC_WRAP_EN_AP_CLOCK_I2C5, CLK_TOP_I2C, 0),
	GATE_IMP_IIC_WRAP(CLK_IMP_IIC_WRAP_EN_AP_CLOCK_I2C6, CLK_TOP_I2C, 1),
};

static const struct mtk_gate_regs vpp0_0_cg_regs = {
	.set_ofs = 0x24,
	.clr_ofs = 0x28,
	.sta_ofs = 0x20,
};

static const struct mtk_gate_regs vpp0_1_cg_regs = {
	.set_ofs = 0x30,
	.clr_ofs = 0x34,
	.sta_ofs = 0x2c,
};

static const struct mtk_gate_regs vpp0_2_cg_regs = {
	.set_ofs = 0x3c,
	.clr_ofs = 0x40,
	.sta_ofs = 0x38,
};

#define GATE_VPP0_0(_id, _parent, _shift)			\
	GATE_MTK_FLAGS(_id, _parent, &vpp0_0_cg_regs, _shift, \
		CLK_PARENT_TOPCKGEN | CLK_GATE_SETCLR)

#define GATE_VPP0_1(_id, _parent, _shift)			\
	GATE_MTK_FLAGS(_id, _parent, &vpp0_1_cg_regs, _shift, \
		CLK_PARENT_TOPCKGEN | CLK_GATE_SETCLR)

#define GATE_VPP0_2(_id, _parent, _shift)			\
	GATE_MTK_FLAGS(_id, _parent, &vpp0_2_cg_regs, _shift, \
		CLK_PARENT_TOPCKGEN | CLK_GATE_SETCLR)

static const struct mtk_gate vpp0_clks[] = {
	/* VPP0_0 */
	GATE_VPP0_0(CLK_VPP0_MDP_FG, CLK_TOP_VPP, 1),
	GATE_VPP0_0(CLK_VPP0_STITCH, CLK_TOP_VPP, 2),
	GATE_VPP0_0(CLK_VPP0_PADDING, CLK_TOP_VPP, 7),
	GATE_VPP0_0(CLK_VPP0_MDP_TCC, CLK_TOP_VPP, 8),
	GATE_VPP0_0(CLK_VPP0_WARP0_ASYNC_TX, CLK_TOP_VPP, 10),
	GATE_VPP0_0(CLK_VPP0_WARP1_ASYNC_TX, CLK_TOP_VPP, 11),
	GATE_VPP0_0(CLK_VPP0_MUTEX, CLK_TOP_VPP, 13),
	GATE_VPP0_0(CLK_VPP02VPP1_RELAY, CLK_TOP_VPP, 14),
	GATE_VPP0_0(CLK_VPP0_VPP12VPP0_ASYNC, CLK_TOP_VPP, 15),
	GATE_VPP0_0(CLK_VPP0_MMSYSRAM_TOP, CLK_TOP_VPP, 16),
	GATE_VPP0_0(CLK_VPP0_MDP_AAL, CLK_TOP_VPP, 17),
	GATE_VPP0_0(CLK_VPP0_MDP_RSZ, CLK_TOP_VPP, 18),
	/* VPP0_1 */
	GATE_VPP0_1(CLK_VPP0_SMI_COMMON_MMSRAM, CLK_TOP_VPP, 0),
	GATE_VPP0_1(CLK_VPP0_GALS_VDO0_LARB0_MMSRAM, CLK_TOP_VPP, 1),
	GATE_VPP0_1(CLK_VPP0_GALS_VDO0_LARB1_MMSRAM, CLK_TOP_VPP, 2),
	GATE_VPP0_1(CLK_VPP0_GALS_VENCSYS_MMSRAM, CLK_TOP_VPP, 3),
	GATE_VPP0_1(CLK_VPP0_GALS_VENCSYS_CORE1_MMSRAM, CLK_TOP_VPP, 4),
	GATE_VPP0_1(CLK_VPP0_GALS_INFRA_MMSRAM, CLK_TOP_VPP, 5),
	GATE_VPP0_1(CLK_VPP0_GALS_CAMSYS_MMSRAM, CLK_TOP_VPP, 6),
	GATE_VPP0_1(CLK_VPP0_GALS_VPP1_LARB5_MMSRAM, CLK_TOP_VPP, 7),
	GATE_VPP0_1(CLK_VPP0_GALS_VPP1_LARB6_MMSRAM, CLK_TOP_VPP, 8),
	GATE_VPP0_1(CLK_VPP0_SMI_REORDER_MMSRAM, CLK_TOP_VPP, 9),
	GATE_VPP0_1(CLK_VPP0_SMI_IOMMU, CLK_TOP_VPP, 10),
	GATE_VPP0_1(CLK_VPP0_GALS_IMGSYS_CAMSYS, CLK_TOP_VPP, 11),
	GATE_VPP0_1(CLK_VPP0_MDP_RDMA, CLK_TOP_VPP, 12),
	GATE_VPP0_1(CLK_VPP0_MDP_WROT, CLK_TOP_VPP, 13),
	GATE_VPP0_1(CLK_VPP0_GALS_EMI0_EMI1, CLK_TOP_VPP, 16),
	GATE_VPP0_1(CLK_VPP0_SMI_SUB_COMMON_REORDER, CLK_TOP_VPP, 17),
	GATE_VPP0_1(CLK_VPP0_SMI_RSI, CLK_TOP_VPP, 18),
	GATE_VPP0_1(CLK_VPP0_SMI_COMMON_LARB4, CLK_TOP_VPP, 19),
	GATE_VPP0_1(CLK_VPP0_GALS_VDEC_VDEC_CORE1, CLK_TOP_VPP, 20),
	GATE_VPP0_1(CLK_VPP0_GALS_VPP1_WPESYS, CLK_TOP_VPP, 21),
	GATE_VPP0_1(CLK_VPP0_GALS_VDO0_VDO1_VENCSYS_CORE1, CLK_TOP_VPP, 22),
	GATE_VPP0_1(CLK_VPP0_FAKE_ENG, CLK_TOP_VPP, 23),
	GATE_VPP0_1(CLK_VPP0_MDP_HDR, CLK_TOP_VPP, 24),
	GATE_VPP0_1(CLK_VPP0_MDP_TDSHP, CLK_TOP_VPP, 25),
	GATE_VPP0_1(CLK_VPP0_MDP_COLOR, CLK_TOP_VPP, 26),
	GATE_VPP0_1(CLK_VPP0_MDP_OVL, CLK_TOP_VPP, 27),
	GATE_VPP0_1(CLK_VPP0_DSIP_RDMA, CLK_TOP_VPP, 28),
	GATE_VPP0_1(CLK_VPP0_DISP_WDMA, CLK_TOP_VPP, 29),
	GATE_VPP0_1(CLK_VPP0_MDP_HMS, CLK_TOP_VPP, 30),
	/* VPP0_2 */
	GATE_VPP0_2(CLK_VPP0_WARP0_RELAY, CLK_TOP_WPE_VPP, 0),
	GATE_VPP0_2(CLK_VPP0_WARP0_ASYNC, CLK_TOP_WPE_VPP, 1),
	GATE_VPP0_2(CLK_VPP0_WARP1_RELAY, CLK_TOP_WPE_VPP, 2),
	GATE_VPP0_2(CLK_VPP0_WARP1_ASYNC, CLK_TOP_WPE_VPP, 3),
};

static const struct mtk_gate_regs vpp1_0_cg_regs = {
	.set_ofs = 0x104,
	.clr_ofs = 0x108,
	.sta_ofs = 0x100,
};

static const struct mtk_gate_regs vpp1_1_cg_regs = {
	.set_ofs = 0x114,
	.clr_ofs = 0x118,
	.sta_ofs = 0x110,
};

#define GATE_VPP1_0(_id, _parent, _shift)			\
	GATE_MTK_FLAGS(_id, _parent, &vpp1_0_cg_regs, _shift,\
		CLK_PARENT_TOPCKGEN | CLK_GATE_SETCLR)

#define GATE_VPP1_1(_id, _parent, _shift)			\
	GATE_MTK_FLAGS(_id, _parent, &vpp1_1_cg_regs, _shift,\
		CLK_PARENT_TOPCKGEN | CLK_GATE_SETCLR)

static const struct mtk_gate vpp1_clks[] = {
	/* VPP1_0 */
	GATE_VPP1_0(CLK_VPP1_SVPP1_MDP_OVL, CLK_TOP_VPP, 0),
	GATE_VPP1_0(CLK_VPP1_SVPP1_MDP_TCC, CLK_TOP_VPP, 1),
	GATE_VPP1_0(CLK_VPP1_SVPP1_MDP_WROT, CLK_TOP_VPP, 2),
	GATE_VPP1_0(CLK_VPP1_SVPP1_VPP_PAD, CLK_TOP_VPP, 3),
	GATE_VPP1_0(CLK_VPP1_SVPP2_MDP_WROT, CLK_TOP_VPP, 4),
	GATE_VPP1_0(CLK_VPP1_SVPP2_VPP_PAD, CLK_TOP_VPP, 5),
	GATE_VPP1_0(CLK_VPP1_SVPP3_MDP_WROT, CLK_TOP_VPP, 6),
	GATE_VPP1_0(CLK_VPP1_SVPP3_VPP_PAD, CLK_TOP_VPP, 7),
	GATE_VPP1_0(CLK_VPP1_SVPP1_MDP_RDMA, CLK_TOP_VPP, 8),
	GATE_VPP1_0(CLK_VPP1_SVPP1_MDP_FG, CLK_TOP_VPP, 9),
	GATE_VPP1_0(CLK_VPP1_SVPP2_MDP_RDMA, CLK_TOP_VPP, 10),
	GATE_VPP1_0(CLK_VPP1_SVPP2_MDP_FG, CLK_TOP_VPP, 11),
	GATE_VPP1_0(CLK_VPP1_SVPP3_MDP_RDMA, CLK_TOP_VPP, 12),
	GATE_VPP1_0(CLK_VPP1_SVPP3_MDP_FG, CLK_TOP_VPP, 13),
	GATE_VPP1_0(CLK_VPP1_VPP_SPLIT, CLK_TOP_VPP, 14),
	GATE_VPP1_0(CLK_VPP1_SVPP2_VDO0_DL_RELAY, CLK_TOP_VPP, 15),
	GATE_VPP1_0(CLK_VPP1_SVPP1_MDP_RSZ, CLK_TOP_VPP, 16),
	GATE_VPP1_0(CLK_VPP1_SVPP1_MDP_TDSHP, CLK_TOP_VPP, 17),
	GATE_VPP1_0(CLK_VPP1_SVPP1_MDP_COLOR, CLK_TOP_VPP, 18),
	GATE_VPP1_0(CLK_VPP1_SVPP3_VDO1_DL_RELAY, CLK_TOP_VPP, 19),
	GATE_VPP1_0(CLK_VPP1_SVPP2_MDP_RSZ, CLK_TOP_VPP, 20),
	GATE_VPP1_0(CLK_VPP1_SVPP2_VPP_MERGE, CLK_TOP_VPP, 21),
	GATE_VPP1_0(CLK_VPP1_SVPP2_MDP_TDSHP, CLK_TOP_VPP, 22),
	GATE_VPP1_0(CLK_VPP1_SVPP2_MDP_COLOR, CLK_TOP_VPP, 23),
	GATE_VPP1_0(CLK_VPP1_SVPP3_MDP_RSZ, CLK_TOP_VPP, 24),
	GATE_VPP1_0(CLK_VPP1_SVPP3_VPP_MERGE, CLK_TOP_VPP, 25),
	GATE_VPP1_0(CLK_VPP1_SVPP3_MDP_TDSHP, CLK_TOP_VPP, 26),
	GATE_VPP1_0(CLK_VPP1_SVPP3_MDP_COLOR, CLK_TOP_VPP, 27),
	GATE_VPP1_0(CLK_VPP1_GALS5, CLK_TOP_VPP, 28),
	GATE_VPP1_0(CLK_VPP1_GALS6, CLK_TOP_VPP, 29),
	GATE_VPP1_0(CLK_VPP1_LARB5, CLK_TOP_VPP, 30),
	GATE_VPP1_0(CLK_VPP1_LARB6, CLK_TOP_VPP, 31),
	/* VPP1_1 */
	GATE_VPP1_1(CLK_VPP1_SVPP1_MDP_HDR, CLK_TOP_VPP, 0),
	GATE_VPP1_1(CLK_VPP1_SVPP1_MDP_AAL, CLK_TOP_VPP, 1),
	GATE_VPP1_1(CLK_VPP1_SVPP2_MDP_HDR, CLK_TOP_VPP, 2),
	GATE_VPP1_1(CLK_VPP1_SVPP2_MDP_AAL, CLK_TOP_VPP, 3),
	GATE_VPP1_1(CLK_VPP1_SVPP3_MDP_HDR, CLK_TOP_VPP, 4),
	GATE_VPP1_1(CLK_VPP1_SVPP3_MDP_AAL, CLK_TOP_VPP, 5),
	GATE_VPP1_1(CLK_VPP1_DISP_MUTEX, CLK_TOP_VPP, 7),
	GATE_VPP1_1(CLK_VPP1_SVPP2_VDO1_DL_RELAY, CLK_TOP_VPP, 8),
	GATE_VPP1_1(CLK_VPP1_SVPP3_VDO0_DL_RELAY, CLK_TOP_VPP, 9),
	GATE_VPP1_1(CLK_VPP1_VPP0_DL_ASYNC, CLK_TOP_VPP, 10),
	GATE_VPP1_1(CLK_VPP1_VPP0_DL1_RELAY, CLK_TOP_VPP, 11),
	GATE_VPP1_1(CLK_VPP1_LARB5_FAKE_ENG, CLK_TOP_VPP, 12),
	GATE_VPP1_1(CLK_VPP1_LARB6_FAKE_ENG, CLK_TOP_VPP, 13),
	GATE_VPP1_1(CLK_VPP1_HDMI_META, CLK_TOP_VPP, 16),
	GATE_VPP1_1(CLK_VPP1_VPP_SPLIT_HDMI, CLK_TOP_VPP, 17),
	GATE_VPP1_1(CLK_VPP1_DGI_IN, CLK_TOP_VPP, 18),
	GATE_VPP1_1(CLK_VPP1_DGI_OUT, CLK_TOP_VPP, 19),
	GATE_VPP1_1(CLK_VPP1_VPP_SPLIT_DGI, CLK_TOP_VPP, 20),
	GATE_VPP1_1(CLK_VPP1_DL_CON_OCC, CLK_TOP_VPP, 21),
	GATE_VPP1_1(CLK_VPP1_VPP_SPLIT_26M, CLK_TOP_VPP, 26),
};

static const struct mtk_gate_regs vdo0_0_cg_regs = {
	.set_ofs = 0x104,
	.clr_ofs = 0x108,
	.sta_ofs = 0x100,
};

static const struct mtk_gate_regs vdo0_1_cg_regs = {
	.set_ofs = 0x114,
	.clr_ofs = 0x118,
	.sta_ofs = 0x110,
};

static const struct mtk_gate_regs vdo0_2_cg_regs = {
	.set_ofs = 0x124,
	.clr_ofs = 0x128,
	.sta_ofs = 0x120,
};

#define GATE_VDO0_0(_id, _parent, _shift)			\
	GATE_MTK_FLAGS(_id, _parent, &vdo0_0_cg_regs, _shift, \
		CLK_PARENT_TOPCKGEN | CLK_GATE_SETCLR)

#define GATE_VDO0_1(_id, _parent, _shift)			\
	GATE_MTK_FLAGS(_id, _parent, &vdo0_1_cg_regs, _shift, \
		CLK_PARENT_TOPCKGEN | CLK_GATE_SETCLR)

#define GATE_VDO0_2(_id, _parent, _shift)			\
	GATE_MTK_FLAGS(_id, _parent, &vdo0_2_cg_regs, _shift, \
		CLK_PARENT_TOPCKGEN | CLK_GATE_SETCLR)

static const struct mtk_gate vdo0_clks[] = {
	/* VDO0_0 */
	GATE_VDO0_0(CLK_VDO0_DISP_OVL0, CLK_TOP_VPP, 0),
	GATE_VDO0_0(CLK_VDO0_FAKE_ENG0, CLK_TOP_VPP, 2),
	GATE_VDO0_0(CLK_VDO0_DISP_CCORR0, CLK_TOP_VPP, 4),
	GATE_VDO0_0(CLK_VDO0_DISP_MUTEX0, CLK_TOP_VPP, 6),
	GATE_VDO0_0(CLK_VDO0_DISP_GAMMA0, CLK_TOP_VPP, 8),
	GATE_VDO0_0(CLK_VDO0_DISP_DITHER0, CLK_TOP_VPP, 10),
	GATE_VDO0_0(CLK_VDO0_DISP_WDMA0, CLK_TOP_VPP, 17),
	GATE_VDO0_0(CLK_VDO0_DISP_RDMA0, CLK_TOP_VPP, 19),
	GATE_VDO0_0(CLK_VDO0_DSI0, CLK_TOP_VPP, 21),
	GATE_VDO0_0(CLK_VDO0_DSI1, CLK_TOP_VPP, 22),
	GATE_VDO0_0(CLK_VDO0_DSC_WRAP0, CLK_TOP_VPP, 23),
	GATE_VDO0_0(CLK_VDO0_VPP_MERGE0, CLK_TOP_VPP, 24),
	GATE_VDO0_0(CLK_VDO0_DP_INTF0, CLK_TOP_VPP, 25),
	GATE_VDO0_0(CLK_VDO0_DISP_AAL0, CLK_TOP_VPP, 26),
	GATE_VDO0_0(CLK_VDO0_INLINEROT0, CLK_TOP_VPP, 27),
	GATE_VDO0_0(CLK_VDO0_APB_BUS, CLK_TOP_VPP, 28),
	GATE_VDO0_0(CLK_VDO0_DISP_COLOR0, CLK_TOP_VPP, 29),
	GATE_VDO0_0(CLK_VDO0_MDP_WROT0, CLK_TOP_VPP, 30),
	GATE_VDO0_0(CLK_VDO0_DISP_RSZ0, CLK_TOP_VPP, 31),
	/* VDO0_1 */
	GATE_VDO0_1(CLK_VDO0_DISP_POSTMASK0, CLK_TOP_VPP, 0),
	GATE_VDO0_1(CLK_VDO0_FAKE_ENG1, CLK_TOP_VPP, 1),
	GATE_VDO0_1(CLK_VDO0_DL_ASYNC2, CLK_TOP_VPP, 5),
	GATE_VDO0_1(CLK_VDO0_DL_RELAY3, CLK_TOP_VPP, 6),
	GATE_VDO0_1(CLK_VDO0_DL_RELAY4, CLK_TOP_VPP, 7),
	GATE_VDO0_1(CLK_VDO0_SMI_GALS, CLK_TOP_VPP, 10),
	GATE_VDO0_1(CLK_VDO0_SMI_COMMON, CLK_TOP_VPP, 11),
	GATE_VDO0_1(CLK_VDO0_SMI_EMI, CLK_TOP_VPP, 12),
	GATE_VDO0_1(CLK_VDO0_SMI_IOMMU, CLK_TOP_VPP, 13),
	GATE_VDO0_1(CLK_VDO0_SMI_LARB, CLK_TOP_VPP, 14),
	GATE_VDO0_1(CLK_VDO0_SMI_RSI, CLK_TOP_VPP, 15),
	/* VDO0_2 */
	GATE_VDO0_2(CLK_VDO0_DSI0_DSI, CLK_TOP_DSI_OCC, 0),
	GATE_VDO0_2(CLK_VDO0_DSI1_DSI, CLK_TOP_DSI_OCC, 8),
	GATE_VDO0_2(CLK_VDO0_DP_INTF0_DP_INTF, CLK_TOP_EDP, 16),
};

static const struct mtk_gate_regs vdo1_0_cg_regs = {
	.set_ofs = 0x104,
	.clr_ofs = 0x108,
	.sta_ofs = 0x100,
};

static const struct mtk_gate_regs vdo1_1_cg_regs = {
	.set_ofs = 0x114,
	.clr_ofs = 0x118,
	.sta_ofs = 0x110,
};

static const struct mtk_gate_regs vdo1_2_cg_regs = {
	.set_ofs = 0x124,
	.clr_ofs = 0x128,
	.sta_ofs = 0x120,
};

static const struct mtk_gate_regs vdo1_3_cg_regs = {
	.set_ofs = 0x134,
	.clr_ofs = 0x138,
	.sta_ofs = 0x130,
};

static const struct mtk_gate_regs vdo1_4_cg_regs = {
	.set_ofs = 0x144,
	.clr_ofs = 0x148,
	.sta_ofs = 0x140,
};

#define GATE_VDO1_0(_id, _parent, _shift)			\
	GATE_MTK_FLAGS(_id, _parent, &vdo1_0_cg_regs, _shift, \
		CLK_PARENT_TOPCKGEN | CLK_GATE_SETCLR)

#define GATE_VDO1_1(_id, _parent, _shift)			\
	GATE_MTK_FLAGS(_id, _parent, &vdo1_1_cg_regs, _shift, \
		CLK_PARENT_TOPCKGEN | CLK_GATE_SETCLR)

#define GATE_VDO1_2(_id, _parent, _shift)			\
	GATE_MTK_FLAGS(_id, _parent, &vdo1_2_cg_regs, _shift, \
		CLK_PARENT_TOPCKGEN | CLK_GATE_SETCLR)

#define GATE_VDO1_3(_id, _parent, _shift)			\
	GATE_MTK_FLAGS(_id, _parent, &vdo1_3_cg_regs, _shift, \
		CLK_PARENT_TOPCKGEN | CLK_GATE_SETCLR)

#define GATE_VDO1_4(_id, _parent, _shift)			\
	GATE_MTK_FLAGS(_id, _parent, &vdo1_4_cg_regs, _shift, \
		CLK_PARENT_TOPCKGEN | CLK_GATE_SETCLR)

#define GATE_VDO1_5(_id, _parent, _shift)			\
	GATE_MTK_FLAGS(_id, _parent, &vdo1_5_cg_regs, _shift, \
		CLK_PARENT_TOPCKGEN | CLK_GATE_SETCLR)

static const struct mtk_gate vdo1_clks[] = {
	/* VDO1_0 */
	GATE_VDO1_0(CLK_VDO1_SMI_LARB2, CLK_TOP_VPP, 0),
	GATE_VDO1_0(CLK_VDO1_SMI_LARB3, CLK_TOP_VPP, 1),
	GATE_VDO1_0(CLK_VDO1_GALS, CLK_TOP_VPP, 2),
	GATE_VDO1_0(CLK_VDO1_FAKE_ENG0, CLK_TOP_VPP, 3),
	GATE_VDO1_0(CLK_VDO1_FAKE_ENG1, CLK_TOP_VPP, 4),
	GATE_VDO1_0(CLK_VDO1_MDP_RDMA0, CLK_TOP_VPP, 5),
	GATE_VDO1_0(CLK_VDO1_MDP_RDMA1, CLK_TOP_VPP, 6),
	GATE_VDO1_0(CLK_VDO1_MDP_RDMA2, CLK_TOP_VPP, 7),
	GATE_VDO1_0(CLK_VDO1_MDP_RDMA3, CLK_TOP_VPP, 8),
	GATE_VDO1_0(CLK_VDO1_VPP_MERGE0, CLK_TOP_VPP, 9),
	GATE_VDO1_0(CLK_VDO1_VPP_MERGE1, CLK_TOP_VPP, 10),
	GATE_VDO1_0(CLK_VDO1_VPP_MERGE2, CLK_TOP_VPP, 11),
	/* VDO1_1 */
	GATE_VDO1_1(CLK_VDO1_VPP_MERGE3, CLK_TOP_VPP, 0),
	GATE_VDO1_1(CLK_VDO1_VPP_MERGE4, CLK_TOP_VPP, 1),
	GATE_VDO1_1(CLK_VDO1_VPP2_TO_VDO1_DL_ASYNC, CLK_TOP_VPP, 2),
	GATE_VDO1_1(CLK_VDO1_VPP3_TO_VDO1_DL_ASYNC, CLK_TOP_VPP, 3),
	GATE_VDO1_1(CLK_VDO1_DISP_MUTEX, CLK_TOP_VPP, 4),
	GATE_VDO1_1(CLK_VDO1_MDP_RDMA4, CLK_TOP_VPP, 5),
	GATE_VDO1_1(CLK_VDO1_MDP_RDMA5, CLK_TOP_VPP, 6),
	GATE_VDO1_1(CLK_VDO1_MDP_RDMA6, CLK_TOP_VPP, 7),
	GATE_VDO1_1(CLK_VDO1_MDP_RDMA7, CLK_TOP_VPP, 8),
	GATE_VDO1_1(CLK_VDO1_DP_INTF0_MMCK, CLK_TOP_VPP, 9),
	GATE_VDO1_1(CLK_VDO1_DPI0_MM, CLK_TOP_VPP, 10),
	GATE_VDO1_1(CLK_VDO1_DPI1_MM, CLK_TOP_VPP, 11),
	GATE_VDO1_1(CLK_VDO1_MERGE0_DL_ASYNC, CLK_TOP_VPP, 13),
	GATE_VDO1_1(CLK_VDO1_MERGE1_DL_ASYNC, CLK_TOP_VPP, 14),
	GATE_VDO1_1(CLK_VDO1_MERGE2_DL_ASYNC, CLK_TOP_VPP, 15),
	GATE_VDO1_1(CLK_VDO1_MERGE3_DL_ASYNC, CLK_TOP_VPP, 16),
	GATE_VDO1_1(CLK_VDO1_MERGE4_DL_ASYNC, CLK_TOP_VPP, 17),
	GATE_VDO1_1(CLK_VDO1_DSC_VDO1_DL_ASYNC, CLK_TOP_VPP, 18),
	GATE_VDO1_1(CLK_VDO1_MERGE_VDO1_DL_ASYNC, CLK_TOP_VPP, 19),
	GATE_VDO1_1(CLK_VDO1_PADDING0, CLK_TOP_VPP, 20),
	GATE_VDO1_1(CLK_VDO1_PADDING1, CLK_TOP_VPP, 21),
	GATE_VDO1_1(CLK_VDO1_PADDING2, CLK_TOP_VPP, 22),
	GATE_VDO1_1(CLK_VDO1_PADDING3, CLK_TOP_VPP, 23),
	GATE_VDO1_1(CLK_VDO1_PADDING4, CLK_TOP_VPP, 24),
	GATE_VDO1_1(CLK_VDO1_PADDING5, CLK_TOP_VPP, 25),
	GATE_VDO1_1(CLK_VDO1_PADDING6, CLK_TOP_VPP, 26),
	GATE_VDO1_1(CLK_VDO1_PADDING7, CLK_TOP_VPP, 27),
	GATE_VDO1_1(CLK_VDO1_DISP_RSZ0, CLK_TOP_VPP, 28),
	GATE_VDO1_1(CLK_VDO1_DISP_RSZ1, CLK_TOP_VPP, 29),
	GATE_VDO1_1(CLK_VDO1_DISP_RSZ2, CLK_TOP_VPP, 30),
	GATE_VDO1_1(CLK_VDO1_DISP_RSZ3, CLK_TOP_VPP, 31),
	/* VDO1_2 */
	GATE_VDO1_2(CLK_VDO1_HDR_VDO_FE0, CLK_TOP_VPP, 0),
	GATE_VDO1_2(CLK_VDO1_HDR_GFX_FE0, CLK_TOP_VPP, 1),
	GATE_VDO1_2(CLK_VDO1_HDR_VDO_BE, CLK_TOP_VPP, 2),
	GATE_VDO1_2(CLK_VDO1_HDR_VDO_FE1, CLK_TOP_VPP, 16),
	GATE_VDO1_2(CLK_VDO1_HDR_GFX_FE1, CLK_TOP_VPP, 17),
	GATE_VDO1_2(CLK_VDO1_DISP_MIXER, CLK_TOP_VPP, 18),
	GATE_VDO1_2(CLK_VDO1_HDR_VDO_FE0_DL_ASYNC, CLK_TOP_VPP, 19),
	GATE_VDO1_2(CLK_VDO1_HDR_VDO_FE1_DL_ASYNC, CLK_TOP_VPP, 20),
	GATE_VDO1_2(CLK_VDO1_HDR_GFX_FE0_DL_ASYNC, CLK_TOP_VPP, 21),
	GATE_VDO1_2(CLK_VDO1_HDR_GFX_FE1_DL_ASYNC, CLK_TOP_VPP, 22),
	GATE_VDO1_2(CLK_VDO1_HDR_VDO_BE_DL_ASYNC, CLK_TOP_VPP, 23),
	/* VDO1_3 */
	GATE_VDO1_3(CLK_VDO1_DPI0, CLK_TOP_VPP, 0),
	GATE_VDO1_3(CLK_VDO1_DISP_MONITOR_DPI0, CLK_TOP_VPP, 1),
	GATE_VDO1_3(CLK_VDO1_DPI1, CLK_TOP_VPP, 8),
	GATE_VDO1_3(CLK_VDO1_DISP_MONITOR_DPI1, CLK_TOP_VPP, 9),
	GATE_VDO1_3(CLK_VDO1_DPINTF, CLK_TOP_VPP, 16),
	GATE_VDO1_3(CLK_VDO1_DISP_MONITOR_DPINTF, CLK_TOP_VPP, 17),
	/* VDO1_4 */
	GATE_VDO1_4(CLK_VDO1_26M_SLOW, CLK_TOP_CLK26M, 8),
};

const struct mtk_clk_tree mt8188_clk_tree = {
	.xtal_rate = 26 * MHZ,
	.xtal2_rate = 26 * MHZ,
	.fdivs_offs = CLK_TOP_MFGPLL,
	.muxes_offs = CLK_TOP_AXI,
	.plls = apmixed_plls,
	.fclks = top_fixed_clks,
	.fdivs = top_fixed_divs,
	.muxes = top_muxes,
};

static int mt8188_topckgen_probe(struct udevice *dev)
{
	return mtk_common_clk_init(dev, &mt8188_clk_tree);
}

static int mt8188_topckgen_cg_probe(struct udevice *dev)
{
	return mtk_common_clk_gate_init(dev, &mt8188_clk_tree, top_clks);
}

static int mt8188_apmixedsys_probe(struct udevice *dev)
{
	return mtk_common_clk_init(dev, &mt8188_clk_tree);
}

static int mt8188_infra_ao_probe(struct udevice *dev)
{
	return mtk_common_clk_gate_init(dev, &mt8188_clk_tree, infra_ao_clks);
}

static int mt8188_peri_ao_probe(struct udevice *dev)
{
	return mtk_common_clk_gate_init(dev, &mt8188_clk_tree, peri_ao_clks);
}

static int mt8188_imp_iic_wrap_probe(struct udevice *dev)
{
	return mtk_common_clk_gate_init(dev, &mt8188_clk_tree, dev->driver_data);
}

static int mt8188_vpp0_probe(struct udevice *dev)
{
	return mtk_common_clk_gate_init(dev, &mt8188_clk_tree, vpp0_clks);
}

static int mt8188_vpp1_probe(struct udevice *dev)
{
	return mtk_common_clk_gate_init(dev, &mt8188_clk_tree, vpp1_clks);
}

static int mt8188_vdo0_probe(struct udevice *dev)
{
	return mtk_common_clk_gate_init(dev, &mt8188_clk_tree, vdo0_clks);
}

static int mt8188_vdo1_probe(struct udevice *dev)
{
	return mtk_common_clk_gate_init(dev, &mt8188_clk_tree, vdo1_clks);
}

static const struct udevice_id mt8188_topckgen_compat[] = {
	{ .compatible = "mediatek,mt8188-topckgen", },
	{ }
};

static const struct udevice_id mt8188_topckgen_cg_compat[] = {
	{ .compatible = "mediatek,mt8188-topckgen-cg", },
	{ }
};

static const struct udevice_id mt8188_apmixed[] = {
	{ .compatible = "mediatek,mt8188-apmixedsys", },
	{ }
};

static const struct udevice_id of_match_clk_mt8188_infra_ao[] = {
	{ .compatible = "mediatek,mt8188-infracfg_ao", },
	{ }
};

static const struct udevice_id of_match_clk_mt8188_peri_ao[] = {
	{ .compatible = "mediatek,mt8188-pericfg_ao", },
	{ }
};

static const struct udevice_id of_match_clk_mt8188_imp_iic_wrap[] = {
	{
		.compatible = "mediatek,mt8188-imp_iic_wrap_c",
		.data = &imp_iic_wrap_c_clks,
	}, {
		.compatible = "mediatek,mt8188-imp_iic_wrap_w",
		.data = &imp_iic_wrap_w_clks,
	}, {
		.compatible = "mediatek,mt8188-imp_iic_wrap_en",
		.data = &imp_iic_wrap_en_clks,
	}, {
		/* sentinel */
	}
};

static const struct udevice_id of_match_clk_mt8188_vpp0[] = {
	{ .compatible = "mediatek,mt8188-vpp0", },
	{ }
};

static const struct udevice_id of_match_clk_mt8188_vpp1[] = {
	{ .compatible = "mediatek,mt8188-vpp1", },
	{ }
};

static const struct udevice_id of_match_clk_mt8188_vdo0[] = {
	{ .compatible = "mediatek,mt8188-vdo0", },
	{ }
};

static const struct udevice_id of_match_clk_mt8188_vdo1[] = {
	{ .compatible = "mediatek,mt8188-vdo1", },
	{ }
};

U_BOOT_DRIVER(mtk_clk_topckgen) = {
	.name = "mt8188-topckgen",
	.id = UCLASS_CLK,
	.of_match = mt8188_topckgen_compat,
	.probe = mt8188_topckgen_probe,
	.priv_auto = sizeof(struct mtk_clk_priv),
	.ops = &mtk_clk_topckgen_ops,
	.flags = DM_FLAG_PRE_RELOC,
};

U_BOOT_DRIVER(mtk_clk_topckgen_cg) = {
	.name = "mt8188-topckgen-cg",
	.id = UCLASS_CLK,
	.of_match = mt8188_topckgen_cg_compat,
	.probe = mt8188_topckgen_cg_probe,
	.priv_auto = sizeof(struct mtk_clk_priv),
	.ops = &mtk_clk_gate_ops,
	.flags = DM_FLAG_PRE_RELOC,
};

U_BOOT_DRIVER(mtk_clk_apmixedsys) = {
	.name = "mt8188-apmixedsys",
	.id = UCLASS_CLK,
	.of_match = mt8188_apmixed,
	.probe = mt8188_apmixedsys_probe,
	.priv_auto = sizeof(struct mtk_clk_priv),
	.ops = &mtk_clk_apmixedsys_ops,
	.flags = DM_FLAG_PRE_RELOC,
};

U_BOOT_DRIVER(mtk_clk_infra_ao) = {
	.name = "mt8188-infra_ao",
	.id = UCLASS_CLK,
	.of_match = of_match_clk_mt8188_infra_ao,
	.probe = mt8188_infra_ao_probe,
	.priv_auto = sizeof(struct mtk_clk_priv),
	.ops = &mtk_clk_gate_ops,
	.flags = DM_FLAG_PRE_RELOC,
};

U_BOOT_DRIVER(mtk_clk_peri_ao) = {
	.name = "mt8188-peri_ao",
	.id = UCLASS_CLK,
	.of_match = of_match_clk_mt8188_peri_ao,
	.probe = mt8188_peri_ao_probe,
	.priv_auto = sizeof(struct mtk_clk_priv),
	.ops = &mtk_clk_gate_ops,
	.flags = DM_FLAG_PRE_RELOC,
};

U_BOOT_DRIVER(mtk_clk_imp_iic_wrap) = {
	.name = "mt8188-imp_iic_wrap",
	.id = UCLASS_CLK,
	.of_match = of_match_clk_mt8188_imp_iic_wrap,
	.probe = mt8188_imp_iic_wrap_probe,
	.priv_auto = sizeof(struct mtk_clk_priv),
	.ops = &mtk_clk_gate_ops,
	.flags = DM_FLAG_PRE_RELOC,
};

U_BOOT_DRIVER(mtk_clk_vpp0) = {
	.name = "mt8188-vpp0",
	.id = UCLASS_CLK,
	.of_match = of_match_clk_mt8188_vpp0,
	.probe = mt8188_vpp0_probe,
	.priv_auto = sizeof(struct mtk_clk_priv),
	.ops = &mtk_clk_gate_ops,
	.flags = DM_FLAG_PRE_RELOC,
};

U_BOOT_DRIVER(mtk_clk_vpp1) = {
	.name = "mt8188-vpp1",
	.id = UCLASS_CLK,
	.of_match = of_match_clk_mt8188_vpp1,
	.probe = mt8188_vpp1_probe,
	.priv_auto = sizeof(struct mtk_clk_priv),
	.ops = &mtk_clk_gate_ops,
	.flags = DM_FLAG_PRE_RELOC,
};

U_BOOT_DRIVER(mtk_clk_vdo0) = {
	.name = "mt8188-vdo0",
	.id = UCLASS_CLK,
	.of_match = of_match_clk_mt8188_vdo0,
	.probe = mt8188_vdo0_probe,
	.priv_auto = sizeof(struct mtk_clk_priv),
	.ops = &mtk_clk_gate_ops,
	.flags = DM_FLAG_PRE_RELOC,
};

U_BOOT_DRIVER(mtk_clk_vdo1) = {
	.name = "mt8188-vdo1",
	.id = UCLASS_CLK,
	.of_match = of_match_clk_mt8188_vdo1,
	.probe = mt8188_vdo1_probe,
	.priv_auto = sizeof(struct mtk_clk_priv),
	.ops = &mtk_clk_gate_ops,
	.flags = DM_FLAG_PRE_RELOC,
};
